;-----------------------------------------------------
;procedura zarzadzajca tworzeniem/wstawianiem obiektu
(defun runn#w ( czyedycja#w / zwrot#w ktora#w rekord#w
	            rozm#w a#w b#w t#w l#w
	          czyuszczelka#w centr#w blok#w nazwa#w 
                  nazwadoz#w ppzwrot#w pX#w tblist#w tdata#w samepunkty#w kanal#w
		  akcesoria#w  blokOpisUwagi#w listaPX#w i#w p#w pp#w ppp#w sciezkaB#w) 

		;lokalna konfiguruje opis tu i w master00#w
		(defun blokOpisUwagi#w ( rekord#w akcesoria#w / blok#w nazwadoz#w
						  lamelAtryb#w  rozmiarAtryb#w)

		;rozmiar		  
		(setq  blok#w      (strcat "KFA" (car rekord#w) (cadr rekord#w))
		        nazwadoz#w (strcat "KFA-" (car rekord#w) "x" (cadr rekord#w)))

		;filtr klasa/wysoko ramki
		(setq pp#w (cadr (assoc "WentyleCwkKFA_KlasaFil" akcesoria#w)))
		(cond ((member pp#w '("0"))  (setq ppp#w "H13"))
		      ((member pp#w '("1"))  (setq ppp#w "H14"))
		);cond
		(setq  blok#w     (strcat blok#w ppp#w)
		       nazwadoz#w (strcat nazwadoz#w "-" ppp#w))


		;trzeci wymiar filtra
		(setq  blok#w     (strcat blok#w (caddr rekord#w))
		       nazwadoz#w (strcat nazwadoz#w "-" (caddr rekord#w)))

		;nawiewnik z preostatem lub bez
		(setq pp#w (cadr (assoc "WentyleCwkKFA_Akcesoria" akcesoria#w)))
		(cond ((member pp#w '("0"))  (setq ppp#w ""))
		      ((member pp#w '("1"))  (setq ppp#w "P"))
		      ((member pp#w '("2"))  (setq ppp#w "K"))
		);cond

		(cond ((member ppp#w '("P" "K"))		       
			(setq  blok#w     (strcat blok#w ppp#w)
		       		nazwadoz#w (strcat nazwadoz#w "-" ppp#w))
		      )
                )

		;uwzgldnienie koloru
		(cond (wykonanieALNOR_tu#w  (setq pp#w  wykonanieALNOR_tu#w))
		      (zwrot#w              (setq pp#w (strcat  (car (nth 20 zwrot#w)))))
		      (T (setq pp#w " "))
		);cond
		(setq  blok#w     (strcat blok#w pp#w)
		       nazwadoz#w (strcat nazwadoz#w "-RAL" pp#w))
	    
		           ;blok   nazwa      tytul  uwagi         producent
		(list blok#w nazwadoz#w "Filtr abs.kanaowy" ""  "CWK"
		      lamelAtryb#w  rozmiarAtryb#w)
		);defun


(wl_err1#w)
;pobiera daNE o elemencie
(setq zwrot#w  
(master00#w "WentyleCWK" "Filtr abs.kanaowy " "WentyleCwkKFA" "KFA" "CWK" "  "   "  " 
            "Okno_plusRAL_cwk" czyedycja#w "" nil "0"
            "WentyleCwk(KNF)" "WentyleCwk(KNF_11)" nil nil nil
                              "WentyleCwk(KNF_21)" nil nil nil
             (list (list "Klasa filtra"  "WentyleCwkKFA_KlasaFil")
		   (list "Preostat" "WentyleCwkKFA_Akcesoria") 
             );listaPlikowDanychWyposaenia 
	     nil ;listaWlasnychGabarytw z opisami
));master00#w/setq
(wyl_err1#w)


(if zwrot#w
(progn 

(wl_err1#w)
;przygotowanie danych dla rysunku bloku i do stworzenia bloku
(setq   rekord#w (nth 5 zwrot#w)
            a#w  (atof (nth 0 rekord#w)) b#w  (atof (nth 1 rekord#w)) 
   	    t#w  (atof (nth 2 rekord#w)) l#w  (atof (nth 3 rekord#w))
  czyuszczelka#w (nth 15 zwrot#w)
         centr#w (nth 14 zwrot#w) 
         nazwa#w (strcat (car (nth 12 zwrot#w)) (nth 13 zwrot#w) )
         ktora#w (nth 6 zwrot#w) 
     akcesoria#w (nth 16 zwrot#w))

   (setq p#w        (blokOpisUwagi#w rekord#w akcesoria#w)
         blok#w     (car p#w)
         nazwadoz#w (cadr p#w))

                                     ;lamelAtryb#w rozmiarAtryb#w
   (setq nazwadoz#w (list nazwadoz#w (nth 5 p#w)   (nth 6 p#w) ))

   (setq blok#w (strcase (strcat blok#w "_" ktora#w)))

(setq tblist#w '())
(while (setq tdata#w (tblnext "BLOCK" (not tdata#w)))
(setq tblist#w (append tblist#w (list (cdr (assoc 2 tdata#w))))))

;jesli nie samepunkty - narysowanie bloku, else - zwraca wsprzdne samych punktw
(if (not (member blok#w tblist#w)) 
	    (setq samepunkty#w nil)
	    ;else
	    (setq samepunkty#w T ))

(setq wlotwylotx#w "")

;tworzy rysunek bloku lub same wsprzdne punktw styku
(cond
((= ktora#w "11")(setq ppzwrot#w (rys11#w samepunkty#w a#w b#w t#w l#w centr#w nazwa#w wlotwylotx#w)))
((= ktora#w "21")(setq ppzwrot#w (rys21#w samepunkty#w a#w b#w t#w l#w centr#w nazwa#w wlotwylotx#w)))
);cond


;dodanie pola przekroju do kadego punktu z ppzwrot#w
(setq pp#w '())
(foreach i#w (cddr ppzwrot#w)
(cond
((equal (list (car i#w) (cadr i#w)) '("P1" "axbmm"))
        (setq p#w  (/ (* a#w b#w) 1000000.0)                  ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
((equal (list (car i#w) (cadr i#w)) '("P2" "axbmm"))
        (setq p#w  (/ (* a#w b#w) 1000000.0)                  ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
));cond/foreach i#w
(if (and pp#w (= (length pp#w) (- (length ppzwrot#w) 2)))
    (setq ppzwrot#w (list (car ppzwrot#w) (cadr ppzwrot#w))
          ppzwrot#w (append ppzwrot#w  pp#w)))


;jesli nie samepunkty - tworzy blok
(blokuje00#w samepunkty#w blok#w ppzwrot#w zwrot#w)

(wyl_err1#w)

(if czyedycja#w (progn
		;odczytuje punkty PX dopisdopisane ew.wczeniej do edytowanego
		(setq listaPX#w (doprzeniesieniaPX#w (car czyedycja#w)))
		;wstawia blok
		(insert01#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w 
		           (cadr czyedycja#w) (caddr czyedycja#w) czyedycja#w przekrSpec#w)
		;dopisuje wczeniej odczytane PX
		(if listaPX#w (zprzeniesienia#w (entlast) listaPX#w))
		);progn
	;else
	(progn

	;wstawia blok
	(insert00#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w przekrSpec#w)

	;ustawia zmienne globalne
	(globset00#w zwrot#w)

		;export do pliku danych wsplnych nakadki
		(dotxt#w "Wentyle")

		;export do pliku danych tego systemu zczek
		(dotxt00#w "WentyleCwk")

	;rysuje odnonik
	(cond ((= strzal#w "1") (odno_strzalka#w))
	      ( T               (odno_linia#w))  )

	));progn/if not czyedycja

));progn/if
		
(princ)
);defun




;procedura porednia rysunkowa
(defun rys11#w (samepunkty#w a#w b#w t#w l#w centr#w nazwa#w wlotwylotx#w / pX#w p00#w) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje11#w samepunkty#w a#w b#w t#w l#w centr#w nazwa#w))
    ));progn/if

;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                 ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest" (list 0 0)       "") ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "axbmm" (list 0 0)      "") ;dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "axbmm" (list l#w 0) wlotwylotx#w)
));list/setq

ppzwrot#w
);defun





;procedura porednia rysunkowa
(defun rys21#w (samepunkty#w a#w b#w t#w l#w centr#w nazwa#w wlotwylotx#w / pX#w p00#w) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje11#w samepunkty#w b#w a#w t#w l#w centr#w nazwa#w))
    ));progn/if

;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                 ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest" (list 0 0)       "") ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "axbmm" (list 0 0)      "") ;dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "axbmm" (list l#w 0) wlotwylotx#w)
));list/setq

ppzwrot#w
);defun







;procedura rysunkowa
(defun rysuje11#w (samepunkty#w  a b t l centr nazwa1 
                    / pr wskaztu layer szerkol pA pB p0 p1 p2 pX pY pZ styld bokp gorap)

;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
(progn
    ;wskazB - zbir wskaza zmienna globalna
    (setq  wskazB   nil  wskazB   (ssadd)                          
           layer    (getvar "CLAYER"))    

    (setvar "CLAYER" "0")

    ;;;(setvar "CLAYER" layer_zarys)

    (command "_UCS" "_w")(command "_UCS" "_o" centr)

    (setq pX (trans '(0 0) 1 0))

    (command "_PLINE"  (list  0 (/ a 2)) (list  l (/ a 2)) 
                       (list  l (- (/ a 2)))(list  0 (- (/ a 2))) "_c")
                       (ssadd (entlast) wskazB)

   	 (command "_LINE"   (list 0 (- (/ (+ a 60.0) 2))) (list 0 (/ (+ a 60.0) 2)) "")
                       (ssadd (entlast) wskazB)
   	 (command "_LINE"   (list 30.0 (- (/ a 2))) (list 30.0 (/ a 2)) "")
                       (ssadd (entlast) wskazB)
   	 (command "_LINE"   (list l (- (/ (+ a 60.0) 2))) (list l (/ (+ a 60.0) 2)) "")
                       (ssadd (entlast) wskazB)
   	 (command "_LINE"   (list (- l 30.0) (- (/ a 2))) (list (- l 30.0) (/ a 2)) "")
                       (ssadd (entlast) wskazB)

    (command "_PLINE"  (list  (- l 45.0) (* a 0.46)) (list  (- l 45.0) (- (* a 0.46)))
                       (list  (- (- l 45.0) t) (- (* a 0.46))) (list  (- (- l 45.0) t) (* a 0.46)) "_c")
                       (ssadd (entlast) wskazB)
 
         (setq styld (getvar "TEXTSTYLE"))
         (setvar "AFLAGS" 0)
         (command "_ATTDEF" "_p" "" "WENTYLE" "" nazwa1  "_s" styl_wentyle#w
                            "_j" "_bl" (list 0 0) wtext#w "0")
         (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_atrybut#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)  
         (setvar "TEXTSTYLE" styld)
         (command "_UCS" "_p")(command "_UCS" "_p")

(command "_UCS" "_w")(command "_UCS" "_o" pX)
;POINTY - wzgldem pX
(command "_POINT" (list 0 0))(ssadd (entlast) wskazB)
(command "_POINT" (list l 0))(ssadd (entlast) wskazB)
(command "_UCS" "_p")(command "_UCS" "_p")
(setvar "CLAYER" layer)

));progn/if not samepunkty#w

pX
);defun 





