;-----------------------------------------------------
;procedura zarzadzajca tworzeniem/wstawianiem obiektu
(defun runn#w ( czyedycja#w / zwrot#w ktora#w rekord#w
		  rozm#w d1#w rh#w rv#w rl#w doWstawienia#w w#w lustro#w
		  czyuszczelka#w centr#w blok#w nazwa#w nazwadoz#w ppzwrot#w pX#w tblist#w tdata#w samepunkty#w kanal#w
		  akcesoria#w  blokOpisUwagi#w listaPX#w i#w p#w pp#w sciezkaB#w czysymbSkrz#w czyramka#w) 

		;lokalna konfiguruje opis tu i w master00#w
		(defun blokOpisUwagi#w ( rekord#w akcesoria#w / blok#w nazwadoz#w
						  lamelAtryb#w  rozmiarAtryb#w)

		;uwzgldnienie strony wykonania
		(setq pp#w (cadr (assoc "WentyleCwk_VentsGroupVUT160-350PBEC_Autom" akcesoria#w)))
		(cond ((member pp#w '("0"))  (setq ppp#w "A21"))
		      ((member pp#w '("1"))  (setq ppp#w "A14"))
		);cond

		(setq  blok#w     (strcat "VUT" (car rekord#w) "PB" "EC" ppp#w)
		       nazwadoz#w (strcat "VUT" (car rekord#w) "PB" "EC" ppp#w))

	             ;blok   nazwa      tytul  uwagi         producent
		(list blok#w nazwadoz#w "Centrala nawiewno-wywiewna" ""  "Vents Group"
		      lamelAtryb#w  rozmiarAtryb#w)
		);defun

(wl_err1#w)
;pobiera daNE o elemencie
(setq zwrot#w											
(master00#w "WentyleCWK" "Centrala nawiewno-wywiewna " "WentyleCwk_VentsGroupVUT160-350PBEC" "VUT 160-350 PB EC" "Vents Group" "   "   "     " 
            "Okno_plus_cwk" czyedycja#w "" nil "1"
            "WentyleVentsGroup(VUT160-350PBEC)"   "WentyleVentsGroup(VUT160-350PBEC_11)"   "WentyleVentsGroup(VUT160-350PBEC_12)"    "WentyleVentsGroup(VUT160-350PBEC_13)"  nil
                                                   nil                                     "WentyleVentsGroup(VUT160-350PBEC_22)"    nil  nil
             (list (list "Wersja automatyki" "WentyleCwk_VentsGroupVUT160-350PBEC_Autom"));listaPlikowDanychWyposaenia
	     nil ;listaWlasnychGabarytw z opisami
));master00#w/setq
(wyl_err1#w)


(if zwrot#w  
(progn 			

(wl_err1#w)		
;przygotowanie danych dla rysunku bloku i do stworzenia bloku
;rozm#w d1#w b#w d#w h#w l#w 			
(setq   rekord#w  (nth 5 zwrot#w)
            rozm#w (atof (nth 0 rekord#w))			
            d1#w (atof (nth 1 rekord#w))
            rh#w (atof (nth 5 rekord#w))
            rv#w (atof (nth 6 rekord#w))
            rl#w (atof (nth 7 rekord#w))
	
  czyuszczelka#w (nth 15 zwrot#w)
         centr#w (nth 14 zwrot#w) 
         nazwa#w (strcat (car (nth 12 zwrot#w)) (nth 13 zwrot#w) )
         ktora#w (nth 6 zwrot#w)
     akcesoria#w (nth 16 zwrot#w))

   (setq p#w        (blokOpisUwagi#w rekord#w akcesoria#w)
         blok#w     (car p#w)
         nazwadoz#w (cadr p#w))

   (setq sciezkaB#w (strcat scd#w (caar zwrot#w) "\\" "WentyleCwk" "_VG_"
						(substr blok#w 1 (- (strlen blok#w) 3)) ))


                                     ;lamelAtryb#w rozmiarAtryb#w
   (setq nazwadoz#w (list nazwadoz#w (nth 5 p#w)   (nth 6 p#w) ))

   (setq blok#w (strcase (strcat blok#w "_" ktora#w)))


(setq tblist#w '())
(while (setq tdata#w (tblnext "BLOCK" (not tdata#w)))
(setq tblist#w (append tblist#w (list (cdr (assoc 2 tdata#w))))))

;jesli nie samepunkty - narysowanie bloku, else - zwraca wsprzdne samych punktw
(if (not (member blok#w tblist#w)) 
	    (setq samepunkty#w nil)
	    ;else
	    (setq samepunkty#w T ))

;tworzy rysunek bloku lub same wsprzdne punktw styku
(cond
((= ktora#w "11")(setq ppzwrot#w (rys11#w samepunkty#w d1#w rh#w rv#w rl#w centr#w czyuszczelka#w nazwa#w)))
((= ktora#w "12")(setq ppzwrot#w (rys12#w samepunkty#w d1#w rh#w rv#w rl#w centr#w czyuszczelka#w nazwa#w)))
((= ktora#w "13")(setq ppzwrot#w (rys13#w samepunkty#w d1#w rh#w rv#w rl#w centr#w czyuszczelka#w nazwa#w)))
((= ktora#w "22")(setq ppzwrot#w (rys22#w samepunkty#w d1#w rh#w rv#w rl#w centr#w czyuszczelka#w nazwa#w)))
);cond


;dodanie pola przekroju do kadego punktu z ppzwrot#w
(setq pp#w '())
(foreach i#w (cddr ppzwrot#w)
(cond
((equal (list (car i#w) (cadr i#w)) '("P1" "d1mm"))
        (setq p#w  (/ (/ (* pi (* d1#w d1#w)) 4) 1000000.0)     ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
((equal (list (car i#w) (cadr i#w)) '("P2" "d1mm"))
        (setq p#w  (/ (/ (* pi (* d1#w d1#w)) 4) 1000000.0)     ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
));cond/foreach i#w
(if (and pp#w (= (length pp#w) (- (length ppzwrot#w) 2)))
    (setq ppzwrot#w (list (car ppzwrot#w) (cadr ppzwrot#w))
          ppzwrot#w (append ppzwrot#w  pp#w)))



;jesli nie samepunkty - tworzy blok
(blokuje00#w samepunkty#w blok#w ppzwrot#w zwrot#w)

(wyl_err1#w)					

(if czyedycja#w (progn
		;odczytuje punkty PX dopisdopisane ew.wczeniej do edytowanego
		(setq listaPX#w (doprzeniesieniaPX#w (car czyedycja#w)))
		;wstawia blok
		(insert01#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w 
		           (cadr czyedycja#w) (caddr czyedycja#w) czyedycja#w nil)
		;dopisuje wczeniej odczytane PX
		(if listaPX#w (zprzeniesienia#w (entlast) listaPX#w))
		);progn
	;else
	(progn

	;wstawia blok
	(insert00#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w nil)

	;ustawia zmienne globalne
	(globset00#w zwrot#w)

		;export do pliku danych wsplnych nakadki
		(dotxt#w "Wentyle")

		;export do pliku danych tego systemu zczek
		(dotxt00#w "WentyleCwk")			


	;rysuje odnonik
	(cond ((= strzal#w "1") (odno_strzalka#w))
	      ( T               (odno_linia#w))  )

	));progn/if not czyedycja

));progn/if
		
(princ)
);defun





;procedura porednia rysunkowa
(defun rys11#w (samepunkty#w d1#w rh#w rv#w rl#w centr#w czyuszczelka#w nazwa#w / pX#w p00#w) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje11#w samepunkty#w d1#w rh#w rv#w rl#w centr#w czyuszczelka#w nazwa#w))
    ));progn/if

;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                   ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest" (list 0 0)       "") ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "d1mm" (list 0 0)         "") ;dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "d1mm" (list (- rh#w) rv#w) "")
));list/setq

ppzwrot#w
);defun






;procedura porednia rysunkowa
(defun rys12#w (samepunkty#w d1#w rh#w rv#w rl#w centr#w czyuszczelka#w nazwa#w / pX#w p00#w) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje11#w samepunkty#w d1#w rh#w rv#w rl#w centr#w czyuszczelka#w nazwa#w))
    ));progn/if

;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                   ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest" (list 0 0)       "") ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "d1mm" (list 0 0)         "") ;dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "d1mm" (list rl#w rv#w) "")
));list/setq

ppzwrot#w
);defun






;procedura porednia rysunkowa
(defun rys13#w (samepunkty#w d1#w rh#w rv#w rl#w centr#w czyuszczelka#w nazwa#w / pX#w p00#w) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje11#w samepunkty#w d1#w rh#w rv#w rl#w centr#w czyuszczelka#w nazwa#w))
    ));progn/if

;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                   ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest" (list 0 0)       "") ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "d1mm" (list 0 0)         "") ;dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "d1mm" (list rh#w rv#w) "")
));list/setq

ppzwrot#w
);defun





;procedura porednia rysunkowa
(defun rys22#w (samepunkty#w d1#w rh#w rv#w rl#w centr#w czyuszczelka#w nazwa#w / pX#w p00#w) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje11#w samepunkty#w d1#w rh#w rv#w rl#w centr#w czyuszczelka#w nazwa#w))
    ));progn/if

;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                   ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest" (list 0 0)       "") ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "d1mm" (list 0 0)         "") ;dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "d1mm" (list rl#w 0) "")
));list/setq

ppzwrot#w
);defun








;procedura rysunkowa
(defun rysuje11#w (samepunkty#w d1 rh rv rl centr czyuszczelka nazwa1 
                    / pr wskaztu layer szerkol rm c pA pB p0 p1 p2 pX pY pZ styld )

;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
(progn
    ;wskazB - zbir wskaza zmienna globalna
    (setq  wskazB   nil  wskazB   (ssadd)                          
           layer    (getvar "CLAYER"))    

    (setvar "CLAYER" "0")

    (command "_UCS" "_w")(command "_UCS" "_o" centr)
    (setq pX  (trans '(0 0) 1 0)
    );setq 

    (command "_INSERT" (strcat sciezkaB#w "_" ktora#w) (list 0 0) "" "" "") (ssadd (entlast) wskazB)

         (setq styld (getvar "TEXTSTYLE"))
         (setvar "AFLAGS" 0)
         (command "_ATTDEF" "_p" "" "WENTYLE" "" nazwa1  "_s" styl_wentyle#w
                            "_j" "_bl" (list 0 0) wtext#w "0")
         (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_atrybut#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)  
         (setvar "TEXTSTYLE" styld)
         (command "_UCS" "_p")(command "_UCS" "_p")

(command "_UCS" "_w")(command "_UCS" "_o" pX)
;POINTY - wzgldem pX

(cond
 
((member ktora#w '("11"))(progn
(command "_POINT" (list 0 0)   )(ssadd (entlast) wskazB)
(command "_POINT" (list (- rh) rv)  )(ssadd (entlast) wskazB)
));progn+

((member ktora#w '("12"))(progn
(command "_POINT" (list 0 0)      )(ssadd (entlast) wskazB)
(command "_POINT" (list rl rv) )(ssadd (entlast) wskazB)
));progn+

((member ktora#w '("13"))(progn
(command "_POINT" (list 0 0)   )(ssadd (entlast) wskazB)
(command "_POINT" (list rh rv)  )(ssadd (entlast) wskazB)
));progn+

((member ktora#w '("22"))(progn
(command "_POINT" (list 0 0)      )(ssadd (entlast) wskazB)
(command "_POINT" (list rl 0) )(ssadd (entlast) wskazB)
));progn+

);cond

(command "_UCS" "_p")(command "_UCS" "_p")
(setvar "CLAYER" layer) 

));progn/if not samepunkty#w

pX
);defun 