;-----------------------------------------------------
;procedura zarzadzajca tworzeniem/wstawianiem obiektu
(defun runn#w ( czyedycja#w / zwrot#w ktora#w rekord#w l#w d1#w l1#w czyuszczelka#w centr#w blok#w nazwa#w 
                  nazwadoz#w ppzwrot#w pX#w tblist#w tdata#w samepunkty#w kanal#w
		  akcesoria#w  blokOpisUwagi#w listaPX#w i#w p#w pp#w sciezkaB#w) 

		;lokalna konfiguruje opis tu i w master00#w
		(defun blokOpisUwagi#w ( rekord#w akcesoria#w / blok#w nazwadoz#w
						  lamelAtryb#w  rozmiarAtryb#w)

		(setq  blok#w     (strcat "QPBA"  (substr (nth 0 rekord#w) 1 3)) 
		       nazwadoz#w (strcat "QPBA-" (substr (nth 0 rekord#w) 1 3)))

		;uwzgldnienie rodzaju przycza
		(setq pp#w (cadr (assoc "WentyleFlaktbQPBA_Model" akcesoria#w)))
		(cond ((member pp#w '("0"))  (setq ppp#w "1"))
		      ((member pp#w '("1"))  (setq ppp#w "2"))
		);cond
		(setq  blok#w     (strcat blok#w ppp#w)
		       nazwadoz#w (strcat nazwadoz#w "-" ppp#w))

	             ;blok   nazwa      tytul  uwagi         producent
		(list blok#w nazwadoz#w "Pasywna belka chodzca" ""  "FLAKT Bovent"  
		      lamelAtryb#w  rozmiarAtryb#w)
		);defun

(wl_err1#w)
;pobiera daNE o elemencie
(setq zwrot#w
(master00#w "WentyleFlaktb" "Pasywna belka chodzca " "WentyleFlaktbQPBA" "QPBA" "FLAKT Bovent" ""   "  " 
            "Okno_plus_fb" czyedycja#w "" nil "0"
            "WentyleFlaktb(QPBA)"  "WentyleFlaktb(QPBA_11)" "WentyleFlaktb(QPBA_12)" nil nil
                                   "WentyleFlaktb(QPBA_21)" nil                      nil nil
            (list (list "Konstrukcja" "WentyleFlaktbQPBA_Model"));listaPlikowDanychWyposaenia
	     nil ;listaWlasnychGabarytw z opisami
));master00#w/setq
(wyl_err1#w)


(if zwrot#w  
(progn

(wl_err1#w)
;przygotowanie danych dla rysunku bloku i do stworzenia bloku
(setq   rekord#w   (nth 5 zwrot#w)
             l1#w  (atof (nth 0 rekord#w))
	     d1#w  10 ;------------------------- merytorycznie nieistotne
  czyuszczelka#w (nth 15 zwrot#w)
         centr#w (nth 14 zwrot#w)
         nazwa#w (strcat (car (nth 12 zwrot#w)) (nth 13 zwrot#w) )
         ktora#w (nth 6 zwrot#w)
     akcesoria#w (nth 16 zwrot#w))

   (setq p#w        (blokOpisUwagi#w rekord#w akcesoria#w)
         blok#w     (car p#w)
         nazwadoz#w (cadr p#w))

   (setq sciezkaB#w (strcat scd#w (caar zwrot#w) "\\" "WentyleFlaktb" (nth 11 zwrot#w) ))


                                     ;lamelAtryb#w rozmiarAtryb#w
   (setq nazwadoz#w (list nazwadoz#w (nth 5 p#w)   (nth 6 p#w) ))

   (setq blok#w (strcase (strcat blok#w "_" ktora#w)))

(setq tblist#w '())
(while (setq tdata#w (tblnext "BLOCK" (not tdata#w)))
(setq tblist#w (append tblist#w (list (cdr (assoc 2 tdata#w))))))

;jesli nie samepunkty - narysowanie bloku, else - zwraca wsprzdne samych punktw
(if (not (member blok#w tblist#w)) 
	    (setq samepunkty#w nil)
	    ;else
	    (setq samepunkty#w T ))

;tworzy rysunek bloku lub same wsprzdne punktw styku
(cond
((= ktora#w "11")(setq ppzwrot#w (rys11#w samepunkty#w sciezkaB#w l1#w d1#w centr#w czyuszczelka#w nazwa#w)))
((= ktora#w "12")(setq ppzwrot#w (rys12#w samepunkty#w sciezkaB#w l1#w d1#w centr#w czyuszczelka#w nazwa#w)))
((= ktora#w "21")(setq ppzwrot#w (rys21#w samepunkty#w sciezkaB#w l1#w d1#w centr#w czyuszczelka#w nazwa#w)))
);cond

;dodanie pola przekroju do kadego punktu z ppzwrot#w
(setq pp#w '())
(foreach i#w (cddr ppzwrot#w)
(cond
((equal (list (car i#w) (cadr i#w)) '("P1" "d1mm"))
        (setq p#w  (/ (/ (* pi (* d1#w d1#w)) 4) 1000000.0)     ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
((equal (list (car i#w) (cadr i#w)) '("P2" "d1mm"))
        (setq p#w  (/ (/ (* pi (* d1#w d1#w)) 4) 1000000.0)     ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
((equal (list (car i#w) (cadr i#w)) '("P3" "d1mm"))
        (setq p#w  (/ (/ (* pi (* d1#w d1#w)) 4) 1000000.0)     ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
));cond/foreach i#w
(if (and pp#w (= (length pp#w) (- (length ppzwrot#w) 2)))
    (setq ppzwrot#w (list (car ppzwrot#w) (cadr ppzwrot#w))
          ppzwrot#w (append ppzwrot#w  pp#w)))

;jesli nie samepunkty - tworzy blok
(blokuje00#w samepunkty#w blok#w ppzwrot#w zwrot#w)

(wyl_err1#w)

(if czyedycja#w (progn
		;odczytuje punkty PX dopisdopisane ew.wczeniej do edytowanego
		(setq listaPX#w (doprzeniesieniaPX#w (car czyedycja#w)))
		;wstawia blok
		(insert01#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w 
		           (cadr czyedycja#w) (caddr czyedycja#w) czyedycja#w nil)
		;dopisuje wczeniej odczytane PX
		(if listaPX#w (zprzeniesienia#w (entlast) listaPX#w))
		);progn
	;else
	(progn

	;wstawia blok
	(insert00#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w nil)

	;ustawia zmienne globalne
	(globset00#w zwrot#w)

		;export do pliku danych wsplnych nakadki
		(dotxt#w "Wentyle")

		;export do pliku danych tego systemu zczek
		(dotxt00#w "WentyleFlaktb")


	;rysuje odnonik
	(cond ((= strzal#w "1") (odno_strzalka#w))
	      ( T               (odno_linia#w))  )

	));progn/if not czyedycja

));progn/if
		
(princ)
);defun







;procedura porednia rysunkowa
(defun rys11#w (samepunkty#w sciezkaB#w l1#w d1#w centr#w czyuszczelka#w nazwa#w / pX#w p00#w) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje11#w samepunkty#w sciezkaB#w l1#w d1#w centr#w czyuszczelka#w nazwa#w))
    ));progn/if

;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                  ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest" (list 0 0)        "") ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "d1mm" (list 0.0 0.0) "") ;dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "d1mm" (list 10.0 0.0) "")
  ;dodany trzeci punkt aby oszuka obliczanie nowododanego obiektu
  (list "P3" "d1mm" (list 0.0 10.0) "")
));list/setq

ppzwrot#w
);defun







;procedura porednia rysunkowa
(defun rys12#w (samepunkty#w sciezkaB#w l1#w d1#w centr#w czyuszczelka#w nazwa#w / pX#w p00#w) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje12#w samepunkty#w sciezkaB#w l1#w d1#w centr#w czyuszczelka#w nazwa#w))
    ));progn/if

;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                  ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest" (list 0 0)        "") ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "d1mm" (list 0.0 0.0) "") ;dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "d1mm" (list 10.0 0.0) "")
  ;dodany trzeci punkt aby oszuka obliczanie nowododanego obiektu
  (list "P3" "d1mm" (list 0.0 10.0) "")
));list/setq

ppzwrot#w
);defun







;procedura porednia rysunkowa
(defun rys21#w (samepunkty#w sciezkaB#w l1#w d1#w centr#w czyuszczelka#w nazwa#w / pX#w p00#w) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje21#w samepunkty#w sciezkaB#w l1#w d1#w centr#w czyuszczelka#w nazwa#w))
    ));progn/if

;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                  ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest" (list 0 0)        "") ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "d1mm" (list 0.0 0.0) "") ;dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "d1mm" (list 10.0 0.0) "")
  ;dodany trzeci punkt aby oszuka obliczanie nowododanego obiektu
  (list "P3" "d1mm" (list 0.0 10.0) "")
));list/setq

ppzwrot#w
);defun








;procedura rysunkowa
(defun rysuje11#w (samepunkty#w sciezkaB#w l d1 centr czyuszczelka nazwa1 
                    / l1 zero_tu pr wskaztu layer szerkol rm c pr pA pB p0 p1 p2 pX pY pZ styld 
		      szczelina )

;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
(progn
    ;wskazB - zbir wskaza zmienna globalna
    (setq  wskazB   nil  wskazB   (ssadd)                          
           layer    (getvar "CLAYER"))    

    (setvar "CLAYER" "0")

    (command "_UCS" "_w")(command "_UCS" "_o" centr)
    (setq   c   20.0
	    b   430.0
	    pr  75.0
	    pX  (trans (list 0 0) 1 0)
    );setq 

    (command "_PLINE" (list 0 0)(list l 0)(list l b)(list 0 b) "_c")(ssadd (entlast) wskazB)
    (command "_PLINE" (list c c)(list (- l c) c)(list (- l c) (- b c))(list c (- b c)) "_c")(ssadd (entlast) wskazB)

    (command "_HATCH" "_u" "45" pr "_Y" (entlast) "")(ssadd (entlast) wskazB)


         (setq styld (getvar "TEXTSTYLE"))
         (setvar "AFLAGS" 0)
         (command "_ATTDEF" "_p" "" "WENTYLE" "" nazwa1  "_s" styl_wentyle#w
                            "_j" "_bl" (list 0 0) wtext#w "0")
         (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_atrybut#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)  
         (setvar "TEXTSTYLE" styld)
         (command "_UCS" "_p")(command "_UCS" "_p")
 
;;;;(command "_UCS" "_w")(command "_UCS" "_o" pX)
;;;;;POINTY - wzgldem pX
;;;;(command "_POINT" (list 0.0 264.0))(ssadd (entlast) wskazB)
;;;;(command "_POINT" (list (/ l 2) 0))(ssadd (entlast) wskazB)
;;;;(command "_UCS" "_p")(command "_UCS" "_p")
(setvar "CLAYER" layer) 

));progn/if not samepunkty#w

pX
);defun 








;procedura rysunkowa
(defun rysuje12#w (samepunkty#w sciezkaB#w l d1 centr czyuszczelka nazwa1 
                    / l1 zero_tu pr wskaztu layer szerkol rm c pr pA pB p0 p1 p2 pX pY pZ styld 
		      szczelina )

;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
(progn
    ;wskazB - zbir wskaza zmienna globalna
    (setq  wskazB   nil  wskazB   (ssadd)                          
           layer    (getvar "CLAYER"))    

    (setvar "CLAYER" "0")

    (command "_UCS" "_w")(command "_UCS" "_o" centr)
    (setq   c   215.0
	    b   430.0
	    pr  142.0
	    pX  (trans (list 0 0) 1 0)
    );setq 

    (command "_PLINE" (list 0 0)(list 0 b)(list pr b)(list pr 0) "_c")(ssadd (entlast) wskazB)
    (command "_PLINE" (list pr 0)(list c (- c pr))(list c (- b (- c pr)))(list pr b) "")(ssadd (entlast) wskazB)


         (setq styld (getvar "TEXTSTYLE"))
         (setvar "AFLAGS" 0)
         (command "_ATTDEF" "_p" "" "WENTYLE" "" nazwa1  "_s" styl_wentyle#w
                            "_j" "_bl" (list 0 0) wtext#w "0")
         (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_atrybut#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)  
         (setvar "TEXTSTYLE" styld)
         (command "_UCS" "_p")(command "_UCS" "_p")
 
;;;;(command "_UCS" "_w")(command "_UCS" "_o" pX)
;;;;;POINTY - wzgldem pX
;;;;(command "_POINT" (list 0.0 264.0))(ssadd (entlast) wskazB)
;;;;(command "_POINT" (list (/ l 2) 0))(ssadd (entlast) wskazB)
;;;;(command "_UCS" "_p")(command "_UCS" "_p")
(setvar "CLAYER" layer) 

));progn/if not samepunkty#w

pX
);defun 








;procedura rysunkowa
(defun rysuje21#w (samepunkty#w sciezkaB#w l d1 centr czyuszczelka nazwa1 
                    / l1 zero_tu pr wskaztu layer szerkol rm c pr pA pB p0 p1 p2 pX pY pZ styld 
		      szczelina )

;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
(progn
    ;wskazB - zbir wskaza zmienna globalna
    (setq  wskazB   nil  wskazB   (ssadd)                          
           layer    (getvar "CLAYER"))    

    (setvar "CLAYER" "0")

    (command "_UCS" "_w")(command "_UCS" "_o" centr)
    (setq   c   215.0
	    b   430.0
	    pr  142.0
	    pX  (trans (list 0 0) 1 0)
    );setq 

    (command "_PLINE" (list 0 0)(list l 0)(list l pr)(list 0 pr) "_c")(ssadd (entlast) wskazB)
    (command "_PLINE" (list (* 0.75 l) pr)(list (* 0.75 l) c)(list (+ (* 0.75 l) 60.0) c)(list (+ (* 0.75 l) 60.0) pr) "")(ssadd (entlast) wskazB)
    (command "_PLINE" (list (* 0.25 l) pr)(list (* 0.25 l) c)(list (- (* 0.25 l) 60.0) c)(list (- (* 0.25 l) 60.0) pr) "")(ssadd (entlast) wskazB)


         (setq styld (getvar "TEXTSTYLE"))
         (setvar "AFLAGS" 0)
         (command "_ATTDEF" "_p" "" "WENTYLE" "" nazwa1  "_s" styl_wentyle#w
                            "_j" "_bl" (list 0 0) wtext#w "0")
         (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_atrybut#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)  
         (setvar "TEXTSTYLE" styld)
         (command "_UCS" "_p")(command "_UCS" "_p")
 
;;;;(command "_UCS" "_w")(command "_UCS" "_o" pX)
;;;;;POINTY - wzgldem pX
;;;;(command "_POINT" (list 0.0 264.0))(ssadd (entlast) wskazB)
;;;;(command "_POINT" (list (/ l 2) 0))(ssadd (entlast) wskazB)
;;;;(command "_UCS" "_p")(command "_UCS" "_p")
(setvar "CLAYER" layer) 

));progn/if not samepunkty#w

pX
);defun 











