;-----------------------------------------------------
;procedura zarzadzajca tworzeniem/wstawianiem obiektu
(defun runn#w ( czyedycja#w / zwrot#w ktora#w rekord#w
	        
	         typ#w a#w b#w 
	         czyuszczelka#w centr#w blok#w nazwa#w 
                  nazwadoz#w ppzwrot#w pX#w tblist#w tdata#w samepunkty#w blokOpisUwagi#w p#w listaPX#w	      
 		  i#w p#w pp#w przekrSpec#w                 
	       ) 

		;lokalna konfiguruje opis tu i w master00#w
		(defun blokOpisUwagi#w ( rekord#w akcesoria#w / blok#w nazwadoz#w
						  lamelAtryb#w  rozmiarAtryb#w ppbl#w)

		(setq  blok#w     (car rekord#w)
		       nazwadoz#w (car rekord#w)
		) 

		;uwzgldnienie wersji 
		(setq pp#w (cadr (assoc "WentyleHarmannCAPP-EC_Wyk" akcesoria#w)))
		(cond ((member pp#w '("0"))  (setq ppp#w "EC"))	
		      ((member pp#w '("1"))  (setq ppp#w "PT"))		      
		);cond
		(setq  blok#w     (strcat blok#w ppp#w)
		       nazwadoz#w (strcat nazwadoz#w  ppp#w))

                         (list blok#w nazwadoz#w  "Wentylator dachowy" "" "Harmann"
                lamelAtryb#w  rozmiarAtryb#w)
           );defun 


(wl_err1#w)
;pobiera dane o elemencie
(setq zwrot#w
(master00#w  "WentyleHarmann" "Wentylator dachowy"  "WentyleHarmannCAPP-EC"  "CAPP.EC CAPP.PT"  "Harmann"  "   " "   "
             "Okno_plus_hm"  czyedycja#w  ""  nil "0"
             "WentyleHarmann(CAPP)" "WentyleHarmann(CAPP_11)" nil nil nil
                                      "WentyleHarmann(CAPP_21)" nil nil nil
             (list (list "Wykonanie:" "WentyleHarmannCAPP-EC_Wyk") );listaPlikowDanychWyposaenia
	     nil ;listaWlasnychGabarytw z opisami
));master00#w/set
(wyl_err1#w)


(if zwrot#w  
(progn 



(wl_err1#w)
;przygotowanie danych dla rysunku bloku i do stworzenia bloku
(setq   rekord#w (nth 5 zwrot#w)

typ#w  (nth 0 rekord#w)
a#w (atof (nth 1 rekord#w))
b#w (atof (nth 2 rekord#w))

   czyuszczelka#w (nth 15 zwrot#w)
         centr#w (nth 14 zwrot#w) 
         nazwa#w (strcat (car (nth 12 zwrot#w)) (nth 13 zwrot#w) )
         ktora#w (nth 6 zwrot#w)
     akcesoria#w (nth 16 zwrot#w))


   (setq p#w        (blokOpisUwagi#w rekord#w akcesoria#w)
         blok#w     (car p#w)
         nazwadoz#w (cadr p#w))

  	(setq sciezkaB#w (strcat scd#w (caar zwrot#w) "\\"  "CAPP_" ktora#w))

                                     ;lamelAtryb#w rozmiarAtryb#w
   (setq nazwadoz#w (list nazwadoz#w (nth 5 p#w)   (nth 6 p#w) ))

   (setq blok#w (strcase (strcat blok#w "_" ktora#w)))

(setq tblist#w '())
(while (setq tdata#w (tblnext "BLOCK" (not tdata#w)))
(setq tblist#w (append tblist#w (list (cdr (assoc 2 tdata#w))))))



;jesli nie samepunkty - narysowanie bloku, else - zwraca wsprzdne samych punktw
(if (not (member blok#w tblist#w)) 
	    (setq samepunkty#w nil)
	    ;else
	    (setq samepunkty#w T ))


;tworzy rysunek bloku lub same wsprzdne punktw styku
(cond
((= ktora#w "11")(setq ppzwrot#w (rys11#w samepunkty#w  typ#w a#w b#w      centr#w czyuszczelka#w nazwa#w)))
((= ktora#w "21")(setq ppzwrot#w (rys21#w samepunkty#w  typ#w a#w b#w      centr#w czyuszczelka#w nazwa#w)))
);cond

;************************
;dodanie pola przekroju do kadego punktu z ppzwrot#w
(setq pp#w '())
(foreach i#w (cddr ppzwrot#w)
(cond
((equal (list (car i#w) (cadr i#w)) '("P1" "axamm"))
        (setq p#w  (/ (* a#w a#w) 1000000.0)                    ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
((equal (list (car i#w) (cadr i#w)) '("P2" "axamm"))
        (setq p#w  (/ (* a#w a#w) 1000000.0)                    ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )

));cond/foreach i#w
(if (and pp#w (= (length pp#w) (- (length ppzwrot#w) 2)))
    (setq ppzwrot#w (list (car ppzwrot#w) (cadr ppzwrot#w))
          ppzwrot#w (append ppzwrot#w  pp#w)))

;jesli nie samepunkty - tworzy blok
(blokuje00#w samepunkty#w blok#w ppzwrot#w zwrot#w)

(wyl_err1#w)						

(if czyedycja#w (progn
		;odczytuje punkty PX dopisdopisane ew.wczeniej do edytowanego
		(setq listaPX#w (doprzeniesieniaPX#w (car czyedycja#w)))
		;wstawia blok
		(insert01#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w 
		           (cadr czyedycja#w) (caddr czyedycja#w) czyedycja#w nil)
		;dopisuje wczeniej odczytane PX
		(if listaPX#w (zprzeniesienia#w (entlast) listaPX#w))
			
		);progn
	;else
	(progn

	;wstawia blok
	(insert00#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w nil)


	;ustawia zmienne globalne
	(globset00#w zwrot#w)

		;export do pliku danych wsplnych nakadki
		(dotxt#w "Wentyle")

		;export do pliku danych tego systemu zczek
		(dotxt00#w "WentyleHarmann")			


	;rysuje odnonik
	(cond ((= strzal#w "1") (odno_strzalka#w))
	      ( T               (odno_linia#w))  )

	));progn/if not czyedycja

));progn/if
		
(princ)
);defun




;procedura porednia rysunkowa
(defun rys11#w (samepunkty#w  typ#w a#w b#w      centr#w czyuszczelka#w nazwa#w / pX#w p00#w hc#w bd#w bz#w bzz#w hb#w) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje11#w samepunkty#w typ#w a#w b#w      centr#w czyuszczelka#w nazwa#w))
    ));progn/if

 ; (setq   hc#w (* c#w 0.5))
;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                   ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest" (list 0 0)       "") ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "axamm" (list 0 0)         "") ;dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "axamm" (list 0  b#w) "")
));list/setq

ppzwrot#w
);defun

;procedura porednia rysunkowa
(defun rys21#w (samepunkty#w  typ#w a#w b#w      centr#w czyuszczelka#w nazwa#w / pX#w p00#w hc#w bd#w bz#w bzz#w hb#w) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje21#w samepunkty#w typ#w a#w b#w      centr#w czyuszczelka#w nazwa#w))
    ));progn/if

 
;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                   ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest" (list 0 0)       "") ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "axamm" (list 0 0)         "") ;dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "axamm" (list (* 0.55 a#w) 0) "")
));list/setq

ppzwrot#w
);defun



;procedura rysunkowa
(defun rysuje11#w (samepunkty#w  typ a b    centr czyuszczelka nazwa1 
                    / pr wskaztu layer  pX pY pZ styld k
		    w1 w2 w3 w4 w4 w5 h1 h2  p1 p2 p3 p4 p5 aa fe skok yz)

;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
(progn
    ;wskazB - zbir wskaza zmienna globalna
    (setq  wskazB   nil  wskazB   (ssadd)                          
           layer    (getvar "CLAYER"))    

    (setvar "CLAYER" "0")

   (command "_UCS" "_w")(command "_UCS" "_o" centr)
    (setq pX  (trans '(0 0) 1 0)
        w1 (* 0.1 b)
        w3 (* 0.1 b)
    	w4 (* 0.2 b)
        w2 (- b (+ w1 w3 w4))
	w5 (* 0.5 w1)
	h1 (* 0.9 (* 0.5 a))
	h2 (* 0.6 (* 0.5 a))  
	
    );setq


  (command "_pline" (list (- (* 0.5 a)) 0)(list (* 0.5 a) 0)(list (* 0.5 a) w1)(list (- (* 0.5 a)) w1) "_c")
                   (ssadd (entlast) wskazB)
  (command "_pline" (list (- h1) w1)(list (- h1) (+ w1 w2))(list (- h2) (+ w1 w2 w3))(list (- h2) (+ w1 w2 w3 w4))
	            (list h2 (+ w1 w2 w3 w4))(list h2 (+ w1 w2 w3))(list h1 (+ w1 w2))(list h1 w1)"")
                    (ssadd (entlast) wskazB)
  (command "_line" (list (- h2)(+ w1 w2 w3))(list h2 (+ w1 w2 w3))"")(ssadd (entlast) wskazB)
  (command "_line" (list (- h1)(+ w1 w5))(list h1 (+ w1 w5))"")(ssadd (entlast) wskazB)
  (command "_line" (list (- h1)(+ w1 w5 w5))(list h1 (+ w1 w5 w5))"")(ssadd (entlast) wskazB)
  (command "_line" (list (- h1)(+ w1 w2))(list h1 (+ w1 w2))"")(ssadd (entlast) wskazB)
  (setq skok 0
        skok (+ skok (/ pi 20))) 
  (repeat 9
    (progn
      (setq yz (* (sin skok) h1))
      (command "_line" (list yz (+ w1 w2))(list yz (+ w1 w5 w5))"") (ssadd (entlast) wskazB)
      (command "_line" (list yz  w1)(list yz (+ w1 w5))"") (ssadd (entlast) wskazB)
      (command "_line" (list (- yz) (+ w1 w2))(list (- yz) (+ w1 w5 w5))"") (ssadd (entlast) wskazB)
      (command "_line" (list (- yz)  w1)(list (- yz) (+ w1 w5))"") (ssadd (entlast) wskazB)
      
      (setq skok (+ skok (/ pi 20)))    
    )
  )
  

  
  
    (command "_LINE" '(0 0) (list 0  b) "")
    (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_osie#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)

  
  
         (setq styld (getvar "TEXTSTYLE"))
         (setvar "AFLAGS" 0)
         (command "_ATTDEF" "_p" "" "WENTYLE" "" nazwa1  "_s" styl_wentyle#w
                            "_j" "_bl" (list 0 b) wtext#w "0")
         (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_atrybut#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)  
         (setvar "TEXTSTYLE" styld)
         (command "_UCS" "_p")(command "_UCS" "_p")
  

(command "_UCS" "_w")(command "_UCS" "_o" pX)
;POINTY - wzgldem pX
(command "_POINT" (list 0 0)      )(ssadd (entlast) wskazB)
(command "_POINT" (list 0  b)) (ssadd (entlast) wskazB)
(command "_UCS" "_p")(command "_UCS" "_p")
(setvar "CLAYER" layer) 

));progn/if not samepunkty#w

pX
);defun 


;procedura rysunkowa
(defun rysuje21#w (samepunkty#w  typ a b    centr czyuszczelka nazwa1 
                    / pr wskaztu layer  pX pY pZ styld  kr licz
		    w1 w2 w3 w4 w5 w6 fe 
		    w1 w2 w3 w4 w4 w5 h1 h2  p1 p2 p3 p4 p5 aa fe skok yz)


;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
(progn
    ;wskazB - zbir wskaza zmienna globalna
    (setq  wskazB   nil  wskazB   (ssadd)                          
           layer    (getvar "CLAYER"))    

    (setvar "CLAYER" "0")

   (command "_UCS" "_w")(command "_UCS" "_o" centr)
    (setq pX  (trans '(0 0) 1 0)
    w1 (* 0.1 b)
        w3 (* 0.1 b)
    	w4 (* 0.2 b)
        w2 (- b (+ w1 w3 w4))
	w5 (* 0.5 w1)
	h1 (* 0.9 (* 0.5 a))
	h2 (* 0.6 (* 0.5 a))
	h3 (* 0.5 a)
	h4 (* 0.8 (* 0.5 a))
    );setq
    
    (command "_pline" (list (- h3)(- h3))(list  h3 (- h3))(list  h3 h3)(list (- h3) h3) "_c")(ssadd (entlast) wskazB)
    (command "_circle" (list 0 0) h1)(ssadd (entlast) wskazB)
    (command "_circle" (list 0 0) h2)(ssadd (entlast) wskazB)
    (command "_circle" (list 0 0) h4)(ssadd (entlast) wskazB)
   (setq skok 0
        skok (+ skok (/ (* 2 pi) 36)))
        er (* 0.5 (- h4 h1))
  (repeat 36
    (progn
      (command "_line" (polar (list 0 0) skok h4) (polar (list 0 0) skok h1)"")(ssadd (entlast) wskazB)
     
      (setq skok (+ skok (/ (* 2 pi) 36)))    
    )
  )
    

  

    (command "_LINE" (list (- (* 0.55 a)) 0)(list  (* 0.55 a) 0) "")
    (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_osie#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)

    (command "_LINE" (list 0 (- (* 0.55 a)))(list 0 (* 0.55 a)) "")
    (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_osie#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)


  
  
         (setq styld (getvar "TEXTSTYLE"))
         (setvar "AFLAGS" 0)
         (command "_ATTDEF" "_p" "" "WENTYLE" "" nazwa1  "_s" styl_wentyle#w
                            "_j" "_bl" (list 0 b) wtext#w "0")
         (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_atrybut#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)  
         (setvar "TEXTSTYLE" styld)
         (command "_UCS" "_p")(command "_UCS" "_p")

(command "_UCS" "_w")(command "_UCS" "_o" pX)
;POINTY - wzgldem pX
(command "_POINT" (list 0 0)      )(ssadd (entlast) wskazB)
(command "_POINT" (list (* 0.55 a) 0)  )(ssadd (entlast) wskazB)
(command "_UCS" "_p")(command "_UCS" "_p")
(setvar "CLAYER" layer) 

));progn/if not samepunkty#w

pX
);defun 




