;------------------------------------------------------------------
;procedura gwna obliczajca spadki cinie elementw jednego typu
;ELEMENT (jednokierunkowy) W KTRYM dPa ZALENE od innego parametru ni kierunek

(defun obliczPa#w ( sciezkaPlik#w plik#w jm#w jm_wsp#w wszystkieKierPa#w listaDoPa#w / 
                    obi#w rozmiar#w kierunki#w rozmiar#w i#w j#w zwrot#w zwrotObi#w kiery#w
		    figura#w akcesoria#w parametr#w 
		    dane#w ) 

;jm#w       "_cm#w"
;jm_wsp#w   "0.1"
;zmienna przenoszca razem wykryte kierunki we wszystkich obiektach tego typu
;  wszystkieKierPa#w np.(("P1>P3" "P1>P2")("P1>P2" "P1>P3"))
;po rozpakowaniu listy listaDoPa#w tworzy z jej rekordu:
;  obi#w      
;  rozmiar#w  (("A mm" "100") ("B mm" "200") ("A1 mm" "80") ("B1 mm" "100") ("L mm" "300") ("E mm" "25"))
;  kierunki#w (("P1" "axbmm" "200" (271.027 227.321 0.0) "P2" "a1xb1mm" "200" (301.027 226.321 0.0)))
;  kiery#w    (("P3>P1" "P2>P1") ("P2>P1" "P3>P1")) - ju po podwojeniu-odwrceniu poniej
;  dalsze nie w kadym elemencie potrzebne:
;  figura#w   "12"
;  akcesoria#w (("" "")) lub (("WentyleSpiroRGS_akcesoria" "2")("WentyleSpiroRGS_lamelki" "1")
;                             ("WentyleSpiroRGS_przepustnica" "0"))  


;rekonstrukcja wszystkieKierPa#w poniewa na wybr wykresu ma wpyw inna wielko 
;ni kierunki przepywu
(setq wszystkieKierPa#w '())
(foreach i#w listaDoPa#w (setq wszystkieKierPa#w 
                         (append wszystkieKierPa#w (list (cadar (cadr i#w))))))


;zaadowanie danych z pliku
(if (not dane#w)
    (progn (load (strcat sciezkaPlik#w plik#w "_PaData.lsp"))
           (setq dane#w (obliczPa1#w)) ))

;obliczenie spadku cinienia na elemencie
(setq zwrot#w '())

(foreach i#w listaDoPa#w
(progn  (setq obi#w (handent (car i#w))
              kiery#w     (caddr i#w)
	      rozmiar#w   (cadr i#w) 
 	      kierunki#w  (cadddr i#w)
	      akcesoria#w (cadr (cddddr i#w)) )

	(setq zwrotObi#w '())
        (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w 
                                        akcesoria#w dane#w ) 
                             ))))

        (if zwrotObi#w (setq zwrotObi#w (append (list obi#w) zwrotObi#w)))

(if zwrotObi#w (setq zwrot#w (append zwrot#w (list zwrotObi#w))))
));progn/foreach i#w

;zwrot#w ((<Entity name: 2792a90> (("P1>P2") "35" "0;Przekroczony zasig danych o 
;          spadkach!") (("P2>P1") "35" "0;Przekroczony zasig danych o spadkach!")) 
;         (<Entity name: 2792cc8> (("P2>P1") "35" "0;Przekroczony zasig danych o 
;          spadkach!") (("P2>P1") "35" "0;Przekroczony zasig danych o spadkach!")))
zwrot#w
);defun










;podprocedura porednia obliczeniowa spadkw cinie jednego kierunku jednego elementu
(defun liczyPa#w ( i#w rozmiar#w kierunki#w akcesoria#w dane#w / dane1#w dane2#w listaZeStr>#w dmz#w c#w
                   p#w pp#w p1#w p2#w error#w text#w nastawa#w wsp#w
                   kolejnosc#w a#w b#w r#w kat#w wyd#w dzeta#w reszta#w f#w v#w ro#w dPa#w
		   kierTu#w j#w zwrot0#w zwrot#w)

;i#w ("P2>P1")
;rozmiar#w (("A mm" "250") ("B mm" "400"))
;kierunki#w (("P1" "axbmm" "2000.00" (63.1592 16.3692 0.0) "P2" "axbmm" "2000.00" (105.837 46.5469 0.0)))
;dane#w (("0.5" "0.25" "1.30")...)
;akcesoria#w (("WentyleProstokatneSQBFN-135_WyrzutCzerp" "0"))

(if (not dane#w)
    (setq zwrot#w (list "" "0;Brak danych o spadkach cinie" ))

;else - jeli rozmiar uzbrojony w liczenie dPa
(progn

;wsp#w - wspczynnik o jaki pomnoy si cz od kraty na zakoczeniu
(setq nastawa#w (cadar akcesoria#w))
(cond		      ((member nastawa#w '("0"))  (setq nastawa#w "Wyrzutnia" wsp#w "0.6" ))
		      ((member nastawa#w '("1"))  (setq nastawa#w "Czerpnia"  wsp#w "1.0" ))
);cond
(setq kierTu#w (car kierunki#w))

		;wycignicie danych do bezporednich oblicze
		(setq a#w   (/ (atof (cadr (nth 0 rozmiar#w))) 1000)  ;[m]
		      b#w   (/ (atof (cadr (nth 1 rozmiar#w))) 1000)  ;[m]
		      r#w   (/ a#w 2)  			      ;[m]
		      kat#w  "135"                		      ;[stopnie]
		      wyd#w  (atof (nth 2 kierTu#w))		      ;[m3/h]
		      text#w (strcat "0;" nastawa#w) )

;wywoanie odczytu dPa z tablicy/wykresu
;(Stosunek (R+A/2)/A, Stosunek B/A, Dzeta[])
(if (not error#w) 
(setq zwrot#w (LiczyPa_odczytDPa#w  (rtos (/ (+ r#w (/ a#w 2)) a#w) 2 12)
    		                    (rtos (/ b#w a#w) 2 12)
			            dane#w) ));setq/if not error#w

	(setq dzeta#w   (car zwrot#w)
	      reszta#w (cadr zwrot#w))


;zaadowanie danych z pliku dodatkowego, obliczenie wspczynnika korygujcego
;i korekta dzety
;korzysta ze zmiennych procedury nadrzdnej
;(Zawsze "1", Kt [stopnie],Wspczynnik)
(if (not dane1#w)
    (progn (load (strcat sciezkaPlik#w plik#w "_PaData1.lsp"))
           (setq dane1#w (obliczPa1#w)) ))

(setq wspolcz#w (LiczyPa_odczytDPa#w  "1"
    		                      kat#w
			              dane1#w))
	(if (/= dzeta#w "") 
	    (setq dzeta#w  (rtos (* (atof (car wspolcz#w)) (atof (car zwrot#w))) 2 2) ))


	(if (/= dzeta#w "")(setq f#w   (* a#w b#w)                       ;[m2] 
				 wyd#w (/ (atof (nth 2 kierTu#w)) 3600)  ;[m3/s]
				 v#w   (/ wyd#w f#w)                     ;[m/s]
				 ro#w  1.2 ;[kg/m3] gsto powietrza
				dPa#w  (* (atof dzeta#w) (/ (* ro#w (* v#w v#w)) 2)) ;[Pa]
				zwrot0#w (list  (rtos dPa#w 2 2) reszta#w)
			   ));setq/if


;uwzgldnienia spadkw na kratce - warto przyjta jako gwna
(if (not dane2#w)
    (progn (load (strcat sciezkaPlik#w plik#w "_PaData2.lsp"))
           (setq dane2#w (obliczPa1#w)) ))

;wywoanie odczytu dPa z tablicy/wykresu
;("1", V[m/s], DPa[Pa])
(setq zwrot#w (LiczyPa_odczytDPa#w  "1"
    		                    (rtos v#w 2 12)
			            dane2#w))

(if (/= (car zwrot#w) "")
(setq zwrot#w (list  (rtos (+ (atof (car zwrot0#w)) 
			      (* (atof wsp#w) (atof (car zwrot#w)))) 2 2) (cadr zwrot#w))) )

(if (and text#w  (= (cadr zwrot#w) "")) (setq zwrot#w (list (car zwrot#w) text#w)))
(if (and error#w (= (cadr zwrot#w) "")) (setq zwrot#w (list (car zwrot#w) error#w)))

));progn-else/if parametr#w

zwrot#w   ;'("35" "Trjn.przelot") 
	  ;lub np. '("" "0;Przekroczony zakres na wykresie spadkw ci.") 

);defun 

