;-----------------------------------------------------
;procedura zarzadzajca tworzeniem/wstawianiem obiektu
(defun runn#w ( czyedycja#w / zwrot#w ktora#w rekord#w d1#w l#w czyuszczelka#w centr#w blok#w nazwa#w 
                  nazwadoz#w ppzwrot#w pX#w tblist#w tdata#w samepunkty#w blokOpisUwagi#w p#w listaPX#w
 		  i#w p#w pp#w przekrSpec#w) 

		;lokalna konfiguruje opis tu i w master00#w
		(defun blokOpisUwagi#w ( rekord#w akcesoria#w / blok#w nazwadoz#w)

		   (setq  blok#w     (strcat "HRVK45")
		          nazwadoz#w (strcat "[11VE41210]"))

		   (setq   blok#w     (substr blok#w 1 28))

	             ;blok   nazwa       tytul   uwagi         producent
		(list blok#w nazwadoz#w "Kolano 90/45 HRV 200/170" ""  "Vasco")
		);defun

(wl_err1#w)
;pobiera dane o elemencie
(setq zwrot#w
(master00#w "WentyleSpiro" "Kolano 90/45 HRV 200/170 " "WentyleSpiroVascoHRVK45"  "[11VE41210]" "Vasco" " "   "   " 
            "Okno_plus_santech_ws" czyedycja#w "" nil "1"
            "WentyleVasco(HRVK45)" "WentyleVasco(HRVK45_11)" "WentyleVasco(HRVK45_12)"  "WentyleVasco(HRVK45_13)"	  nil
                                    nil                       nil                       nil                               nil 
             nil ;listaPlikowDanychWyposazenia
	     nil ;listaWlasnychGabarytw z opisami
));master00#w/setq
(wyl_err1#w)


(if zwrot#w  
(progn 

(wl_err1#w)

;przygotowanie danych dla rysunku bloku i do stworzenia bloku
(setq   rekord#w (nth 5 zwrot#w)
            d1#w (atof (cadr rekord#w))
             l#w 84.0

         alfa#w 45.0 ;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
         centr#w (nth 14 zwrot#w)
         nazwa#w (strcat (car (nth 12 zwrot#w)) (nth 13 zwrot#w) )
         ktora#w (nth 6 zwrot#w))

   (setq p#w        (blokOpisUwagi#w rekord#w akcesoria#w)
         blok#w     (car p#w)
         nazwadoz#w (cadr p#w))

   (setq blok#w (strcase (strcat blok#w "_" ktora#w)))

(setq tblist#w '())
(while (setq tdata#w (tblnext "BLOCK" (not tdata#w)))
(setq tblist#w (append tblist#w (list (cdr (assoc 2 tdata#w))))))

;jesli nie samepunkty - narysowanie bloku, else - zwraca wsprzdne samych punktw
(if (not (member blok#w tblist#w)) 
	    (setq samepunkty#w nil)
	    ;else
	    (setq samepunkty#w T )) 

;tworzy rysunek bloku lub same wsprzdne punktw styku
(cond
((= ktora#w "11")(setq ppzwrot#w (rys11#w samepunkty#w d1#w l#w alfa#w centr#w nazwa#w)))
((= ktora#w "12")(setq ppzwrot#w (rys12#w samepunkty#w d1#w l#w alfa#w centr#w nazwa#w)))
((= ktora#w "13")(setq ppzwrot#w (rys13#w samepunkty#w d1#w l#w alfa#w centr#w nazwa#w)))
);cond


;dodanie pola przekroju do kadego punktu z ppzwrot#w
(setq pp#w '())
(foreach i#w (cddr ppzwrot#w)
(cond
((equal (list (car i#w) (cadr i#w)) '("P1" "d1mm"))
        (setq p#w  (/ (/ (* pi (* d1#w d1#w)) 4) 1000000.0)     ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
((equal (list (car i#w) (cadr i#w)) '("P2" "d1mm"))
        (setq p#w  (/ (/ (* pi (* d1#w d1#w)) 4) 1000000.0)     ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
));cond/foreach i#w
(if (and pp#w (= (length pp#w) (- (length ppzwrot#w) 2)))
    (setq ppzwrot#w (list (car ppzwrot#w) (cadr ppzwrot#w))
          ppzwrot#w (append ppzwrot#w  pp#w)))


;jesli nie samepunkty - tworzy blok
(blokuje00#w samepunkty#w blok#w ppzwrot#w zwrot#w)

(wyl_err1#w)

(if czyedycja#w (progn
		;odczytuje punkty PX dopisdopisane ew.wczeniej do edytowanego
		(setq listaPX#w (doprzeniesieniaPX#w (car czyedycja#w)))
		;wstawia blok
		(insert01#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w 
		           (cadr czyedycja#w) (caddr czyedycja#w) czyedycja#w przekrSpec#w)
		;dopisuje wczeniej odczytane PX
		(if listaPX#w (zprzeniesienia#w (entlast) listaPX#w))
		);progn
	;else
	(progn

	;wstawia blok			;szuu
	(if tylkoNaSciezce#w		
	(insert01#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w 
		    (cadr czyedycja#w) (caddr czyedycja#w) czyedycja#w nil)
	;else
	(insert00#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w nil))


	;ustawia zmienne globalne
	(globset00#w zwrot#w)

		;export do pliku danych wsplnych nakadki
		(dotxt#w "Wentyle")

		;export do pliku danych tego systemu zczek
		(dotxt00#w "WentyleSpiro")

	;rysuje odnonik
	(cond ((= strzal#w "1") (odno_strzalka#w))
	      ( T               (odno_linia#w))  )

	));progn/if not czyedycja

));progn/if
		
(princ)
);defun







;procedura porednia rysunkowa
(defun rys11#w (samepunkty#w d1#w l#w alfa#w centr#w nazwa#w / pX#w p00#w p11#w alf#w) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje11#w samepunkty#w d1#w l#w alfa#w centr#w nazwa#w))
    ));progn/if

(setq  alf#w  (* (/ pi 180) alfa#w)
       p00#w  (list 0 (* d1#w (/ (sin (/ alf#w 2))(cos (/ alf#w 2)))))
       p11#w  (list (- (* d1#w (- 1 (cos alf#w)))) (* d1#w (sin alf#w))))
;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                   ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest" p00#w              "") ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "d1mm" (list 0 0)         "") ;dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "d1mm" p11#w              "")
));list/setq

ppzwrot#w
);defun




;procedura porednia rysunkowa
(defun rys12#w (samepunkty#w d1#w l#w alfa#w centr#w nazwa#w / pX#w p00#w p11#w alf#w) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje11#w samepunkty#w d1#w l#w alfa#w centr#w nazwa#w))
    (command "_UCS" "_w")(command "_UCS" "_o" pX#w)
       (setq p00#w ( trans pX#w 0 1))
       (command "_MIRRTEXT" "0")
       (command "_MIRROR"  wskazB "" p00#w (list (car p00#w) (+ (cadr p00#w) 100)) "_Y")
    (command "_UCS" "_p")(command "_UCS" "_p")
    ));progn/if

(setq  alf#w  (* (/ pi 180) alfa#w)
       p00#w  (list 0 (* d1#w (/ (sin (/ alf#w 2))(cos (/ alf#w 2)))))
       p11#w  (list   (* d1#w (- 1 (cos alf#w)))  (* d1#w (sin alf#w))))
;wysya  punkty styku rwnie jeli bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest" p00#w          "")  ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "d1mm" (list 0 0)     "")  ;dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "d1mm" p11#w          "")
));list/setq

ppzwrot#w
);defun







;procedura porednia rysunkowa
(defun rys13#w (samepunkty#w d1#w l#w centr#w czyuszczelka#w nazwa#w / pX#w p00#w) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje13#w samepunkty#w d1#w l#w centr#w czyuszczelka#w nazwa#w))
    ));progn/if

;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                 ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest" (list 0 0)   "" )  ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "d1mm" (list 0 0)     "" )  ;dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
));list/setq

ppzwrot#w
);defun










;procedura rysunkowa
(defun rysuje11#w (samepunkty#w d1 l alfa centr nazwa1 
                    / pr wskaztu layer szerkol rm c pA pB pC pA1 pB1 pC1 p0 p1 p2 p3 p11 p21 p31 pX pY pZ styld )

;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
(progn
    ;wskazB - zbir wskaza zmienna globalna
    (setq  wskazB   nil  wskazB   (ssadd)                          
           layer    (getvar "CLAYER"))    

    (setvar "CLAYER" "0")

    (command "_UCS" "_w")(command "_UCS" "_o" centr)
    (setq 
          rm  d1
          pX (trans (list rm 0) 1 0)
     szerkol (* 0.07 d1)
          pA (trans (list (- rm (/ d1 2)) 0) 1 0)
          pB (trans (list (+ rm (/ d1 2)) 0) 1 0)
          pA1 (trans (list (- rm 85.0) 0) 1 0)
          pB1 (trans (list (+ rm 85.0) 0) 1 0)
    );setq 

    (command "_UCS" "_o" (list rm 0))
    (setq 
          pC (trans (list 100.0 125.42) 1 0)
          pC1 (trans (list -100.0 42.37) 1 0)
 	  p01 (trans (list 0 84.0) 1 0)

          p3 (trans (list 85.0 119.149) 1 0)
          p31 (trans (list -85.0 48.728) 1 0)
    );setq 
    (command "_UCS" "_p")

    (command "_UCS" "_z" alfa)(command "_UCS" "_o" (list rm 0))
    (setq p0 (trans '(0 0) 1 0)
          p1 (trans (list (- (/ d1 2)) 0) 1 0)
          p2 (trans (list (/ d1 2) 0) 1 0)  
          p11 (trans (list (- 85.0) 0) 1 0)
          p21 (trans (list 85.0 0) 1 0)  
    );setq 
    (command "_UCS" "_p")(command "_UCS" "_p")

    (command "_PLINE" (trans pA 0 1)(trans pB 0 1)(trans pC 0 1)(trans p2 0 1)(trans p1 0 1)(trans pC1 0 1) "_c")(ssadd (entlast) wskazB)

    (command "_PLINE" (trans pA1 0 1)(trans p31 0 1)(trans p11 0 1) "")(ssadd (entlast) wskazB)
    (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_osie#w)(assoc 8 pr) pr))(entmod pr)
    (setq pr (entget (entlast)))(setq pr (append pr (list (cons 6 "HIDDEN"))))(entmod pr)
                                                               (ssadd (entlast) wskazB)

    (command "_PLINE" (trans pB1 0 1)(trans p3 0 1)(trans p21 0 1) "")(ssadd (entlast) wskazB)
    (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_osie#w)(assoc 8 pr) pr))(entmod pr)
    (setq pr (entget (entlast)))(setq pr (append pr (list (cons 6 "HIDDEN"))))(entmod pr)
                                                               (ssadd (entlast) wskazB)

    (command "_PLINE" (trans pX 0 1)(trans p01 0 1)(trans p0 0 1) "")(ssadd (entlast) wskazB)
    (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_osie#w)(assoc 8 pr) pr))(entmod pr)


         (setq styld (getvar "TEXTSTYLE"))
         (setvar "AFLAGS" 0)
         (command "_ATTDEF" "_p" "" "WENTYLE" "" nazwa1  "_s" styl_wentyle#w
                            "_j" "_bl" (list (/ l 2) 0) wtext#w "0")
         (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_atrybut#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)  
         (setvar "TEXTSTYLE" styld)
         (command "_UCS" "_p")(command "_UCS" "_p")

(command "_UCS" "_w")(command "_UCS" "_o" pX)
;POINTY - wzgldem pX
(command "_POINT" (list 0 0)    )(ssadd (entlast) wskazB)
(command "_POINT" (trans p0 0 1))(ssadd (entlast) wskazB)
(command "_UCS" "_p")(command "_UCS" "_p")
(setvar "CLAYER" layer) 

));progn/if not samepunkty#w

pX
);defun 








;procedura rysunkowa
(defun rysuje13#w (samepunkty#w d1 l alfa centr nazwa1 
                    / pr wskaztu layer szerkol rm c pA pB p0 p1 p2 pX pY pZ styld )

;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
(progn
    ;wskazB - zbir wskaza zmienna globalna
    (setq  wskazB   nil  wskazB   (ssadd)                          
           layer    (getvar "CLAYER"))    

    (setvar "CLAYER" "0")

    (command "_UCS" "_w")(command "_UCS" "_o" centr)
    (setq 
          p0 (trans '(0 0) 1 0))

    (command "_LINE" (list 0 0)(list 0 l) "")
    (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_osie#w)(assoc 8 pr) pr))(entmod pr)
										   (ssadd (entlast) wskazB)
    (command "_LINE" (list (- (+ (/ d1 2) 5)) l) (list (+ (/ d1 2) 5) l) "")
    (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_osie#w)(assoc 8 pr) pr))(entmod pr)
										   (ssadd (entlast) wskazB)
    (command "_LINE"  (list (- (/ d1 2)) 0) (list (/ d1 2) 0) "")
                                           (ssadd (entlast) wskazB)
    (command "_LINE"  (list (- (/ d1 2)) 0) (list (- (/ d1 2)) l) "")
                                           (ssadd (entlast) wskazB)
    (command "_LINE"  (list (/ d1 2) 0) (list (/ d1 2) l) "")
                                           (ssadd (entlast) wskazB)
    (command "_ELLIPSE" "_c" (list 0 l) (list (/ d1 2) l) (list 0 (+ l (/ d1 3)))) (ssadd (entlast) wskazB)


    (command "_LINE"  (list (- 85.0) 0) (list (- 85.0) l) "")
    (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_osie#w)(assoc 8 pr) pr))(entmod pr)
    (setq pr (entget (entlast)))(setq pr (append pr (list (cons 6 "HIDDEN"))))(entmod pr)
                                                               (ssadd (entlast) wskazB)
    (command "_LINE"  (list 85.0 0) (list 85.0 l) "")
    (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_osie#w)(assoc 8 pr) pr))(entmod pr)
    (setq pr (entget (entlast)))(setq pr (append pr (list (cons 6 "HIDDEN"))))(entmod pr)
                                                               (ssadd (entlast) wskazB)
    (command "_ELLIPSE" "_c" (list 0 l) (list 85.0 l) (list 0 (+ l (/ 170.0 3))))
    (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_osie#w)(assoc 8 pr) pr))(entmod pr)
    (setq pr (entget (entlast)))(setq pr (append pr (list (cons 6 "HIDDEN"))))(entmod pr)
                                                               (ssadd (entlast) wskazB)

         (setq styld (getvar "TEXTSTYLE"))
         (setvar "AFLAGS" 0)
         (command "_ATTDEF" "_p" "" "WENTYLE" "" nazwa1  "_s" styl_wentyle#w
                            "_j" "_bl" (list (/ l 2) 0) wtext#w "0")
         (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_atrybut#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)  
         (setvar "TEXTSTYLE" styld)
         (command "_UCS" "_p")(command "_UCS" "_p")

(command "_UCS" "_w")(command "_UCS" "_o" p0)
;POINTY - wzgldem p0
;(command "_POINT" (list 0 l)      )(ssadd (entlast) wskazB)
(command "_POINT" (list 0 0)  )(ssadd (entlast) wskazB)
(command "_UCS" "_p")(command "_UCS" "_p")
(setvar "CLAYER" layer) 

));progn/if not samepunkty#w

p0
);defun 



