;-----------------------------------------------------
;procedura zarzadzajca tworzeniem/wstawianiem obiektu
(defun runn#w ( czyedycja#w / zwrot#w ktora#w rekord#w d1#w d3#w l#w h#w czyuszczelka#w centr#w blok#w nazwa#w 
                  nazwadoz#w ppzwrot#w pX#w tblist#w tdata#w samepunkty#w blokOpisUwagi#w listaPX#w
		  i#w p#w pp#w przekrSpec#w) 

		;lokalna konfiguruje opis tu i w master00#w
		(defun blokOpisUwagi#w ( rekord#w akcesoria#w / blok#w nazwadoz#w)

		   (setq     blok#w (strcat "YSVQT-45"  (car rekord#w)(cadr rekord#w))
		         nazwadoz#w (strcat "YSVQT-45-" (car rekord#w) "-" (cadr rekord#w) "-"))

	        ;akcesoria
		(setq pp#w (cadr (assoc "WentyleSpiroYSVQT-45_grBlachy" akcesoria#w)))
		(cond ((member pp#w '("0"))  (setq ppp#w "0,7"))
		      ((member pp#w '("1"))  (setq ppp#w "0,9"))
		);cond
		(setq  blok#w     (strcat blok#w (substr ppp#w 3)) 
	               nazwadoz#w (strcat nazwadoz#w ppp#w))

	             ;blok   nazwa       tytul   uwagi         producent
		(list blok#w nazwadoz#w "Trjnik orowy TRANS-Quick" ""  "SPIRO Alnor")
		);defun

(wl_err1#w)
;pobiera dane o elemencie
(setq zwrot#w
(master00#w "WentyleSpiro" "Trjnik orowy TRANS-Quick " "WentyleSpiroYSVQT-45"  "YSVQT-45" "SPIRO Alnor" " " "  "
            "Okno_plus_ws" czyedycja#w "" nil "1"
            "WentyleSpiro(yvl)" "WentyleSpiro(yvl_11)" nil   nil   nil
                                   nil   nil   nil   nil  
             (list (list "Grubo blachy:" "WentyleSpiroYSVQT-45_grBlachy"));listaPlikowDanychWyposazenia
	     nil ;listaWlasnychGabarytw z opisami
));master00#w/setq
(wyl_err1#w)


(if zwrot#w  
(progn 

(wl_err1#w)
;przygotowanie danych dla rysunku bloku i do stworzenia bloku
(setq   rekord#w (nth 5 zwrot#w)
            d1#w (atof (car rekord#w))
            d3#w (atof (cadr rekord#w))
             l2#w (atof (caddr rekord#w))
  czyuszczelka#w (nth 15 zwrot#w)
         centr#w (nth 14 zwrot#w) 
         nazwa#w (strcat (car (nth 12 zwrot#w)) (nth 13 zwrot#w) )
         ktora#w (nth 6 zwrot#w)
     akcesoria#w (nth 16 zwrot#w))


   (setq p#w        (blokOpisUwagi#w rekord#w akcesoria#w)
         blok#w     (car p#w)
         nazwadoz#w (cadr p#w))

   (setq blok#w (strcase (strcat blok#w "_" ktora#w)))

(setq tblist#w '())
(while (setq tdata#w (tblnext "BLOCK" (not tdata#w)))
(setq tblist#w (append tblist#w (list (cdr (assoc 2 tdata#w))))))

;jesli nie samepunkty - narysowanie bloku, else - zwraca wsprzdne samych punktw
(if (not (member blok#w tblist#w)) 
	    (setq samepunkty#w nil)
	    ;else
	    (setq samepunkty#w T ))

;tworzy rysunek bloku lub same wsprzdne punktw styku
(cond
((= ktora#w "11")(setq ppzwrot#w (rys11#w samepunkty#w d1#w d3#w l2#w centr#w czyuszczelka#w nazwa#w)))
((= ktora#w "12")(setq ppzwrot#w (rys12#w samepunkty#w d1#w d3#w l2#w centr#w czyuszczelka#w nazwa#w)))
((= ktora#w "13")(setq ppzwrot#w (rys13#w samepunkty#w d1#w d3#w l2#w centr#w czyuszczelka#w nazwa#w)))
((= ktora#w "14")(setq ppzwrot#w (rys14#w samepunkty#w d1#w d3#w l2#w centr#w czyuszczelka#w nazwa#w)))
((= ktora#w "21")(setq ppzwrot#w (rys21#w samepunkty#w d1#w d3#w l2#w centr#w czyuszczelka#w nazwa#w)))
((= ktora#w "22")(setq ppzwrot#w (rys22#w samepunkty#w d1#w d3#w l2#w centr#w czyuszczelka#w nazwa#w)))
((= ktora#w "23")(setq ppzwrot#w (rys23#w samepunkty#w d1#w d3#w l2#w centr#w czyuszczelka#w nazwa#w)))
((= ktora#w "24")(setq ppzwrot#w (rys24#w samepunkty#w d1#w d3#w l2#w centr#w czyuszczelka#w nazwa#w)))
);cond


(setq pp#w '()) 
(foreach i#w (cddr ppzwrot#w)
(cond
((equal (list (car i#w) (cadr i#w)) '("P1" "d1mm"))
        (setq p#w  (/ (/ (* pi (* d1#w d1#w)) 4) 1000000.0)     ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
((equal (list (car i#w) (cadr i#w)) '("P2" "d3mm"))
        (setq p#w  (/ (/ (* pi (* d3#w d3#w)) 4) 1000000.0)     ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
((equal (list (car i#w) (cadr i#w)) '("P3" "d3mm"))
        (setq p#w  (/ (/ (* pi (* d3#w d3#w)) 4) 1000000.0)     ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
));cond/foreach i#w
(if (and pp#w (= (length pp#w) (- (length ppzwrot#w) 2)))
    (setq ppzwrot#w (list (car ppzwrot#w) (cadr ppzwrot#w))
          ppzwrot#w (append ppzwrot#w  pp#w)))


;obliczenie i dodanie do rekord#w i zwrot#w pola rozwinicia
(setq pp#w (rtos 
	   (+
           (/ (* (* pi d3#w) l2#w) 1000000.0) 
	   (/ (* (* pi d3#w) l2#w) 1000000.0) 
	   )
            2 3) );[m2] 
(setq rekord#w (append rekord#w (list pp#w)))
(setq zwrot#w (append (list (nth 0 zwrot#w) (nth 1 zwrot#w) (nth 2 zwrot#w) (nth 3 zwrot#w))
	(list (append  (nth 4 zwrot#w) (list "m2")))
	(list (append  (nth 5 zwrot#w) (list pp#w)))
(cddddr (cddr zwrot#w))
));append/setq



;jesli nie samepunkty - tworzy blok
(blokuje00#w samepunkty#w blok#w ppzwrot#w zwrot#w)

(wyl_err1#w)

(if czyedycja#w (progn
		;odczytuje punkty PX dopisdopisane ew.wczeniej do edytowanego
		(setq listaPX#w (doprzeniesieniaPX#w (car czyedycja#w)))
		;wstawia blok
		(insert01#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w 
		           (cadr czyedycja#w) (caddr czyedycja#w) czyedycja#w nil)
		;dopisuje wczeniej odczytane PX
		(if listaPX#w (zprzeniesienia#w (entlast) listaPX#w))
		);progn
	;else
	(progn

	;wstawia blok
	(insert00#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w nil)

	;ustawia zmienne globalne
	(globset00#w zwrot#w)

		;export do pliku danych wsplnych nakadki
		(dotxt#w "Wentyle")

		;export do pliku danych tego systemu zczek
		(dotxt00#w "WentyleSpiro")


	;rysuje odnonik
	(cond ((= strzal#w "1") (odno_strzalka#w))
	      ( T               (odno_linia#w))  )

	));progn/if not czyedycja

));progn/if
		
(princ)
);defun







;procedura porednia rysunkowa
(defun rys11#w (samepunkty#w d1#w d3#w l2#w centr#w czyuszczelka#w nazwa#w / pX#w szerkol#w) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje11#w samepunkty#w d1#w d3#w l2#w centr#w czyuszczelka#w nazwa#w))
    ));progn/if

(setq szerkol#w (* 0.07 d1#w))

;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	          ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest" 
	(list szerkol#w 0 ) "") ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "d1mm" (list 0 0)         "") ;dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "d3mm"              
	(list
	(+ szerkol#w (* l2#w (sin (/ pi 4))) )
	(* l2#w (cos (/ pi 4))) 
	) "")
  (list "P3" "d3mm"              
	(list
	(+ szerkol#w (* l2#w (sin (/ pi 4))) )
	(- (* l2#w (cos (/ pi 4))))
	) "")
));list/setq

ppzwrot#w
);defun








;procedura rysunkowa
(defun rysuje11#w (samepunkty#w d1 d3 l2 centr czyuszczelka nazwa1 
                    / pr wskaztu layer szerkol rm c pA pB p0 p1 p2 pX pY pZ styld p#w)

;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
(progn
    ;wskazB - zbir wskaza zmienna globalna
    (setq  wskazB   nil  wskazB   (ssadd)   
	   wskaztu  nil  wskaztu   (ssadd)                       
           layer    (getvar "CLAYER"))    

    (setvar "CLAYER" "0")

    (command "_UCS" "_w")(command "_UCS" "_o" centr)
    (setq 
           pX (trans '(0 0) 1 0)
      szerkol (* 0.07 d1)
           p0 (list szerkol 0)
	   p01  (trans p0 1 0)
    );setq 
    (command "_UCS" "_o" p0)(command "_UCS" "_z" "45")(command "_UCS" "_o" (list l2 0 0))
    (setq pY (trans '(0 0) 1 0))
    (command "_PLINE" (list 0 (- (/ d3 2))) (list 0 (/ d3 2)) "_a" 
    (list (- szerkol) (/ d3 2)) "_l" (list (- szerkol) (- (/ d3 2))) "_a" "_cl")
									  (ssadd (entlast) wskazB)
								   	 (ssadd (entlast) wskaztu)
    (command "_LINE" '(0 0) (list (- l2) 0) "")
    (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_osie#w)(assoc 8 pr) pr))(entmod pr)
										   (ssadd (entlast) wskazB)
										   (ssadd (entlast) wskaztu)
    (setq p2 (trans (list (- szerkol) (- (/ d3 2))) 1 0)
          p1 (trans (list (- szerkol)    (/ d3 2))  1 0))
    (command "_UCS" "_p")(command "_UCS" "_p")(command "_UCS" "_p")

    (command "_LINE" '(0 0) (list szerkol 0) "")
    (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_osie#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)
    (command "_LINE" (list szerkol (/ d1 2)) (trans p1 0 1) "")
						   (ssadd (entlast) wskazB)
				  	        (ssadd (entlast) wskaztu)
    (command "_LINE" (list (* 0.5 (sqrt 2.0) d3) 0) (trans p2 0 1) "")
							    (ssadd (entlast) wskazB)
							   (ssadd (entlast) wskaztu)
    (command "_PLINE" (list 0 (- (/ d1 2))) (list 0 (/ d1 2)) "_a" 
    (list szerkol (/ d1 2)) "_l" (list szerkol (- (/ d1 2))) "_a" "_cl")
                                                (ssadd (entlast) wskazB)
         (setq i 0)
         (repeat (sslength wskaztu)
         (progn
         (command "_MIRROR"  (ssname wskaztu i) "" '(0 0) "@100<0" "N")
         (ssadd (entlast) wskazB)
         (setq i (+ 1 i)) ));progn/repeat

         (setq styld (getvar "TEXTSTYLE"))
         (setvar "AFLAGS" 0)
         (command "_ATTDEF" "_p" "" "WENTYLE" "" nazwa1  "_s" styl_wentyle#w
                            "_j" "_bl" (list (/ l2 2) 0) wtext#w "0")
         (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_atrybut#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)  
         (setvar "TEXTSTYLE" styld)
         (command "_UCS" "_p")(command "_UCS" "_p")
 
(command "_UCS" "_w")(command "_UCS" "_o" pX)
;POINTY - wzgldem pX
(setq p01 (trans p01 0 1)
      pY  (trans pY 0 1))
(command "_POINT" (list 0 0)      	)(ssadd (entlast) wskazB)
(command "_POINT" (list
	(+ szerkol (* l2 (sin (/ pi 4))) )
	(* l2 (cos (/ pi 4))) )    )(ssadd (entlast) wskazB)
(command "_POINT" (list
	(+ szerkol  (* l2 (sin (/ pi 4))) )
	(- (* l2 (cos (/ pi 4))) ))    )(ssadd (entlast) wskazB)
(command "_UCS" "_p")(command "_UCS" "_p")
(setvar "CLAYER" layer) 

));progn/if not samepunkty#w

pX
);defun 




