;-----------------------------------------------------
;procedura zarzadzajca tworzeniem/wstawianiem obiektu
(defun runn#w ( czyedycja#w / zwrot#w ktora#w rekord#w  a#w b#w a1#w c#w d#w   y#w cy#w dy#w
		  czyuszczelka#w centr#w blok#w nazwa#w 
                  nazwadoz#w ppzwrot#w pX#w tblist#w tdata#w samepunkty#w blokOpisUwagi#w listaPX#w czyWyk#w Wyk#w
		  i#w p#w pp#w przekrSpec#w) 

		;lokalna konfiguruje opis tu i w master00#w
		(defun blokOpisUwagi#w ( rekord#w akcesoria#w / a#w b#w c#w d#w blok#w nazwadoz#w czyWyk#w Wyk#w)

		(setq blok#w  (strcat "TA-S-Kred" (nth 0 rekord#w) (nth 1 rekord#w)
 					    (nth 2 rekord#w) (nth 3 rekord#w) (nth 4 rekord#w) (cadar akcesoria#w))
		      nazwadoz#w  (strcat "TA-S-Kred "  (nth 0 rekord#w) "x" (nth 1 rekord#w) 
						     "-" (nth 2 rekord#w) " " (nth 3 rekord#w)  " " (nth 4 rekord#w) ))
		(setq blok#w  (substr blok#w 1 28))

	             ;blok   nazwa       tytul  uwagi producent
		(list blok#w nazwadoz#w "Kolano redukcyjne" "" "TOPAIR-Sofik")
		);defun

(wl_err1#w)
;pobiera dane o elemencie
(setq zwrot#w
(master00#w "WentyleTOPAIR-Sofik" "Kolano redukcyjne" "WentyleTOPAIR-SofikKred"  "TA-S-Kred"  "TOPAIR-Sofik" " "   "   " 
            "Okno_wlasneplus2_ur" czyedycja#w "" nil
            "WentyleTOPAIR-Sofik(TA-S-Kred)" "WentyleTOPAIR-Sofik(TA-S-Kred_11)" "WentyleTOPAIR-Sofik(TA-S-Kred_12)" "WentyleTOPAIR-Sofik(TA-S-Kred_13)" nil
                                       nil nil nil nil
             (list (list "Max.cin./Profil wzmocnie:" "WentyleTOPAIR-Sofik_Cisnienie"));listaPlikowDanychWyposaenia
	     (list (list "A mm" "500") (list "B mm" "500") (list "A1 mm" "300") (list "C mm" "") (list "D mm" "")) ;listaWlasnychGabarytw z opisami
            "5" ;ileZlistyDoWlasnych#w 
));master00#w/setq
(wyl_err1#w)
		
(if zwrot#w  
(progn 

(wl_err1#w)
;przygotowanie danych dla rysunku bloku i do stworzenia bloku
(setq   rekord#w (nth 5 zwrot#w)
            a#w   (atof (nth 0 rekord#w))  b#w (atof (nth 1 rekord#w))  a1#w (atof (nth 2 rekord#w)) 
            c#w   (atof (nth 3 rekord#w))  d#w (atof (nth 4 rekord#w))  
         centr#w (nth 14 zwrot#w)
         nazwa#w (strcat (car (nth 12 zwrot#w)) (nth 13 zwrot#w) )
         ktora#w (nth 6 zwrot#w)
     akcesoria#w (nth 15 zwrot#w))

   ;wane tylko przy wstawianiu
   (setq p#w        (blokOpisUwagi#w rekord#w akcesoria#w)
         blok#w     (car p#w)
         nazwadoz#w (cadr p#w))

   ;podmiana niwelujca mylce przydatki literowe w symbolu cigane ywcem z pamitanych wasnych 
   (setq zwrot#w (append (reverse (cddr (reverse zwrot#w))) (list (cons nazwadoz#w (cdr (nth 18 zwrot#w))))
		         (list (car (reverse zwrot#w)))) )

   (setq blok#w (strcase (strcat blok#w "_" ktora#w)))

(setq tblist#w '())
(while (setq tdata#w (tblnext "BLOCK" (not tdata#w)))
(setq tblist#w (append tblist#w (list (cdr (assoc 2 tdata#w))))))

;jesli nie samepunkty - narysowanie bloku, else - zwraca wsprzdne samych punktw
(if (not (member blok#w tblist#w)) 
	    (setq samepunkty#w nil)
	    ;else
	    (setq samepunkty#w T ))

;tworzy rysunek bloku lub same wsprzdne punktw styku
(cond
((= ktora#w "11")(setq ppzwrot#w (rys11#w samepunkty#w a#w b#w c#w d#w a1#w centr#w nazwa#w)))
((= ktora#w "12")(setq ppzwrot#w (rys12#w samepunkty#w a#w b#w c#w d#w a1#w centr#w nazwa#w)))
((= ktora#w "13")(setq ppzwrot#w (rys13#w samepunkty#w a#w b#w c#w d#w a1#w centr#w nazwa#w)))
);cond


;dodanie pola przekroju do kadego punktu z ppzwrot#w
;dla zczek, gdzie zdarzaj si rzuty z obcit list punktw
;std ostatni czon liczcy  przekrSpec#w
(setq pp#w '())
(foreach i#w '(("P1" "a1xbmm") ("P2" "axbmm"))
(cond
((equal (list (car i#w) (cadr i#w)) '("P1" "a1xbmm"))
        (setq p#w  (/ (* a#w b#w) 1000000.0)                    ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
((equal (list (car i#w) (cadr i#w)) '("P2" "axbmm"))
        (setq p#w  (/ (* a#w b#w) 1000000.0)                   ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
));cond/foreach i#w
(setq  przekrSpec#w pp#w)


;obliczenie i zaadowanie do rekord#w i zwrot#w pola rozwinicia
;przeliczeniowa dugo wg wzoru: 2b+e+f - uwaga b to tutaj a
(setq p#w (rtos (+ a#w b#w a#w b#w) 2 3));[mm]
(setq   y#w (+ 150.0 (* 2 (* (+ 25.0 (* 0.5 a#w)) (/ (sin (/ pi 8))(cos (/ pi 8))) )))
	cy#w (- c#w (/ y#w (sqrt 2)))
	dy#w (- d#w (/ y#w (sqrt 2)))
	pp#w (rtos (* 0.000001 (* (atof p#w)
				(+ y#w cy#w dy#w) )) 2 3));[m2]
(setq rekord#w (append  rekord#w (list p#w pp#w)))
(setq zwrot#w (append (list (nth 0 zwrot#w) (nth 1 zwrot#w) (nth 2 zwrot#w) (nth 3 zwrot#w))
	(list (append  (nth 4 zwrot#w) (list "obw.mm" "m2")))
	(list (append  (nth 5 zwrot#w) (list p#w pp#w)))
(cddddr (cddr zwrot#w))
));append/setq

;jesli nie samepunkty - tworzy blok
(blokuje00#w samepunkty#w blok#w ppzwrot#w zwrot#w)


    ;lokalna 
    ;rozwinicie do specjalnych zestawie dla URSAiru, korzysta z wymiarw z procedury nadrzdnej
    (defun URSAirProcedura#w ( / p#w pp#w dlosi#w sumaOsi#w zewPoprz#w wewPoprz#w
				zwrot#w gr#w xx#w)

;;;;    (if (> c#w d#w) (setq p#w c#w) 
;;;;		    ;else
;;;;	  	    (setq p#w d#w))
;;;;    (setq   p#w  (/ (+ (* 0.001 p#w) (/ (* 0.001 a#w) 2) (* 0.001 (atoi GrTOPAIR-Sofik#w))) (cos (* 22.5 (/ pi 180))) )
;;;;	    pp#w (* (* 3.2 (+ (* 0.001 a#w) (* 0.001 b#w) 0.2)) p#w) ) ;[m2]

    (setq  pp#w (*  (+ (* 2 (+ (* 0.001 a#w) (* 0.001 b#w))) 0.19)
		    (- (+ (* 0.001 c#w)(* 0.001 d#w)) (+ (* 0.172 (* 0.001 a#w)) 0.0621)) )
		);[m2]


    (setq gr#w  (atoi GrTOPAIR-Sofik#w)          ;[m]
	  sumaOsi#w  (* 0.001 (+ c#w d#w))
		xx#w (* 2 (+ (+ a#w gr#w gr#w) (+ b#w gr#w gr#w)))
	  zewPoprz#w (* 0.001 xx#w)          ;zawsze minus jedno
		xx#w (* 2 (+ (* 1.1 (+ a#w gr#w gr#w)) (+ b#w gr#w gr#w)))
	  wewPoprz#w (* 0.001 (* 2 xx#w))
     );setq
		     
    (setq zwrot#w (list "" pp#w "SUMAOSI" sumaOsi#w "ZEWPOPRZ" zewPoprz#w "WEWPOPRZ" wewPoprz#w))
    );defun lokalnej

(setq ppzwrot#w (append (list (URSAirProcedura#w)) ppzwrot#w))


(wyl_err1#w)

(if czyedycja#w (progn
		;odczytuje punkty PX dopisdopisane ew.wczeniej do edytowanego
		(setq listaPX#w (doprzeniesieniaPX#w (car czyedycja#w)))
		;wstawia blok
		(insert01#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w 
		           (cadr czyedycja#w) (caddr czyedycja#w) czyedycja#w przekrSpec#w)
		;dopisuje wczeniej odczytane PX
		(if listaPX#w (zprzeniesienia#w (entlast) listaPX#w))
		);progn
	;else
	(progn

	;wstawia blok		
	(if tylkoNaSciezce#w		
	(insert01#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w 
		    (cadr czyedycja#w) (caddr czyedycja#w) czyedycja#w przekrSpec#w)
	;else
	(insert00#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w przekrSpec#w))

	;ustawia zmienne globalne
	(globset00#w zwrot#w)

		;export do pliku danych wsplnych nakadki
		(dotxt#w "Wentyle")

		;export do pliku danych tego systemu zczek
		(dotxt00#w "WentyleTOPAIR-Sofik")

	;rysuje odnonik
	(cond ((= strzal#w "1") (odno_strzalka#w))
	      ( T               (odno_linia#w))  )

	));progn/if not czyedycja

));progn/if
		
(princ)
);defun







;procedura porednia rysunkowa
(defun rys11#w (samepunkty#w a#w b#w c#w d#w a1#w centr#w nazwa#w / pX#w p00#w ) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje11#w samepunkty#w a#w b#w c#w d#w a1#w centr#w nazwa#w))
    ));progn/if

;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                   ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest"  (list 0 0)        "") ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "a1xbmm" (list c#w 0)      "") ;dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "axbmm" (list 0 (- d#w)) "")
));list/setq

ppzwrot#w
);defun






;procedura porednia rysunkowa
(defun rys12#w (samepunkty#w a#w b#w c#w d#w a1#w centr#w nazwa#w / pX#w p00#w ) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje11#w samepunkty#w a#w b#w c#w d#w a1#w centr#w nazwa#w))
    (command "_UCS" "_w")(command "_UCS" "_o" pX#w)
       (setq p00#w ( trans pX#w 0 1))
       (command "_MIRRTEXT" "0")
       (command "_MIRROR"  wskazB "" p00#w (list (car p00#w) (+ (cadr p00#w) 100)) "_Y")
    (command "_UCS" "_p")(command "_UCS" "_p")
    ));progn/if

;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                   ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest"  (list 0 0)        "") ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "a1xbmm" (list (- c#w) 0)      "") ;dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "axbmm" (list 0 (- d#w)) "")
));list/setq

ppzwrot#w
);defun







;procedura porednia rysunkowa
(defun rys13#w (samepunkty#w a#w b#w c#w d#w a1#w centr#w nazwa#w / pX#w p00#w ) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje13#w samepunkty#w a#w b#w c#w d#w a1#w centr#w nazwa#w))
    ));progn/if

;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	             ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest"   (list 0 0) "") ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P2" "axbmm"  (list 0 (- d#w)) "")
));list/setq

ppzwrot#w
);defun










;procedura rysunkowa
(defun rysuje11#w (samepunkty#w a b c d a1 centr nazwa1 
                    / gr seg col pr aa bb x c1 c2 c3 s1 s2 s3 s4 pa pa1 pb pb1 pc pc1 pd pd1 skos
		      wskaztu layer szerkol rm c pA pB p0 p1 p2 pX pY pZ styld wzorKier aa)

;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
(progn
    ;wskazB - zbir wskaza zmienna globalna
    (setq  wskazB   nil  wskazB   (ssadd)
           layer    (getvar "CLAYER")
	   gr	(atoi GrTOPAIR-Sofik#w)
	   seg	(atoi SzerTOPAIR-Sofik#w)
	   col  (atoi ColorTOPAIR-Sofik#w))

    (setvar "CLAYER" "0")

    ;;;(setvar "CLAYER" layer_zarys)

    (command "_UCS" "_w")(command "_UCS" "_o" centr)

    (setq pX (trans (list 0 0) 1 0))

    (if (< c d) (setq x (- c 100)) (setq x (- d 100)))

	;ponisze przypisanie x powoduje nadanie skosowi staej wartoci
	;tutaj 150mm, 
	;uwaga powtrzone w czy_masterMoj#w
	(setq skos 150.0
	      x  (+ (/ skos 2) (/ skos (sqrt 2)) gr (/ a 2))
    	      aa (/ (- a a1) 2))

    (command "_UCS" "_o" (list x (- x) ))
    	(command "_UCS" "_z" "-22.5")
    	(setq c1 (trans (list 0 0) 1 0)
   	      c2 (trans (list 1000 0) 1 0))
    	(command "_UCS" "_z" "-45")
    	(setq c3 (trans (list 1000 0) 1 0))
    	(command "_UCS" "_p")(command "_UCS" "_p")
		(setq 
		pa  (inters (trans c1 0 1)(trans c2 0 1)
		        (list (- (+ x (/ a 2))) 0) (list (- (+ x (/ a 2))) 1000) nil) 
		pa1 (inters (trans c1 0 1)(trans c2 0 1)
		        (list (- (+ x (/ a 2) gr)) 0) (list (- (+ x (/ a 2) gr)) 1000) nil) 
		pc  (inters (trans c1 0 1)(trans c2 0 1)
		        (list (- (- x (/ a 2))) 0) (list (- (- x (/ a 2))) 1000) nil) 
		pc1 (inters (trans c1 0 1)(trans c2 0 1)
		        (list (- (- (- x (/ a 2)) gr)) 0) (list (- (- (- x (/ a 2)) gr)) 1000) nil) 
		);setq

		(setq 
		pa  (trans (list (car pa) (- (cadr pa) aa)) 1 0)
		pa1 (trans (list (car pa1) (- (cadr pa1) aa)) 1 0)
		pc  (trans (list (car pc) (+ (cadr pc) aa)) 1 0)
		pc1 (trans (list (car pc1) (+ (cadr pc1) aa)) 1 0)
		);setq

    (command "_UCS" "_o" (list 0 x))
		(setq 
		pd  (inters (trans c1 0 1)(trans c3 0 1)
		        (list 0 (- (/ a 2))) (list 1000 (- (/ a 2))) nil) 
		pd1 (inters (trans c1 0 1)(trans c3 0 1)
		        (list 0 (- (+ (/ a 2) gr))) (list 1000 (- (+ (/ a 2) gr))) nil) 
		pb  (inters (trans c1 0 1)(trans c3 0 1)
		        (list 0 (+ (/ a 2))) (list 1000 (+ (/ a 2))) nil) 
		pb1 (inters (trans c1 0 1)(trans c3 0 1)
		        (list 0 (+ (/ a 2) gr)) (list 1000 (+ (/ a 2) gr)) nil) 
		);setq

		(setq 
		pd  (trans (list (car pd) (+ (cadr pd) aa)) 1 0)
		pd1 (trans (list (car pd1) (+ (cadr pd1) aa)) 1 0)
		pb  (trans (list (car pb) (- (cadr pb) aa)) 1 0)
		pb1 (trans (list (car pb1) (- (cadr pb1) aa)) 1 0)
		);setq

    (command "_UCS" "_p")(command "_UCS" "_p")


    (command "_PLINE" (list (+ (/ a 2) gr) (- d)) (trans pc1 0 1) (trans pd1 0 1) (list c (- (+ (/ a1 2) gr))) 
		      (list c (+ (/ a1 2) gr)) (trans pb1 0 1) (trans pa1 0 1) (list (- (+ (/ a 2) gr)) (- d)) "_c")
		      (ssadd (entlast) wskazB)

    (command "_PLINE" (list (/ a 2) (- d)) (trans pc 0 1) (trans pd 0 1) (list c (- (/ a1 2))) "")
		     (setq pr (entget (entlast)))
	             (setq pr (append pr (list  (cons 62 col) (cons 6 "HIDDEN") )))
		     (entmod pr) (ssadd (entlast) wskazB)

    (command "_PLINE" (list c (/ a1 2)) (trans pb 0 1) (trans pa 0 1) (list (- (/ a 2)) (- d)) "")
		     (setq pr (entget (entlast)))
	             (setq pr (append pr (list  (cons 62 col) (cons 6 "HIDDEN") )))
		     (entmod pr) (ssadd (entlast) wskazB)

;;		;kierownice
;;    		(command "_ARC" "_c" '(0 0) "@87.5<82" "_a" "106")
;;		(setq wzorKier (entlast))
;;		(command "_MOVE" wzorKier "" '(0 0) (list 87.5 -87.5))
;;		(command "_MOVE" wzorKier "" '(0 0) (list (* 0.5 a#w) (- (* 0.5 a#w)))) 
;;		(cond
;;			((and (> a#w 400.0)(<= a#w 800.0))(progn
;;			(command "_COPY" wzorKier"" '(0 0) (list (- (* 0.33 a#w)) (* 0.33 a#w)))
;;							     (ssadd (entlast) wskazB)
;;			));progn+
;;			((and (> a#w 800.0)(<= a#w 1600.0))(progn
;;			(command "_COPY" wzorKier "" '(0 0) (list (- (* 0.25 a#w)) (* 0.25 a#w)))
;;							     (ssadd (entlast) wskazB)
;;			(command "_COPY" wzorKier "" '(0 0) (list (- (* 0.50 a#w)) (* 0.50 a#w)))
;;							     (ssadd (entlast) wskazB)
;;			));progn+
;;			((> a#w 1600.0)(progn
;;			(command "_COPY" wzorKier "" '(0 0) (list (- (* 0.125 a#w)) (* 0.125 a#w)))
;;							     (ssadd (entlast) wskazB)
;;			(command "_COPY" wzorKier "" '(0 0) (list (- (* 0.33 a#w)) (* 0.33 a#w)))
;;							     (ssadd (entlast) wskazB)
;;			(command "_COPY" wzorKier "" '(0 0) (list (- (* 0.50 a#w)) (* 0.50 a#w)))
;;							     (ssadd (entlast) wskazB)
;;			));progn+
;;		);cond
;;		(entdel wzorKier)
		

    (if (czy_wzmoc_Ob#w a#w b#w) (progn  (command "_UCS" "_o" (list c 0))(wzmocnienieObwodowe#w  (list 0 0) -25 a) (command "_UCS" "_p")
	(command "_UCS" "_o" (list 0 (- d)))(command "_UCS" "_z" "-90")(wzmocnienieObwodowe#w  (list 0 0) -25 a) (command "_UCS" "_p")(command "_UCS" "_p")
				 ));progn/if

         (setq styld (getvar "TEXTSTYLE"))
         (setvar "AFLAGS" 0)
         (command "_ATTDEF" "_p" "" "WENTYLE" "" nazwa1  "_s" styl_wentyle#w
                            "_j" "_bl" (list 0 0) wtext#w "0")
         (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_atrybut#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)  
         (setvar "TEXTSTYLE" styld)
         (command "_UCS" "_p")(command "_UCS" "_p")

(command "_UCS" "_w")(command "_UCS" "_o" pX)
;POINTY - wzgldem pX
(command "_POINT" (list 0 (- d)) )(ssadd (entlast) wskazB)
(command "_POINT" (list c 0))(ssadd (entlast) wskazB)
(command "_UCS" "_p")(command "_UCS" "_p")
(setvar "CLAYER" layer) 

));progn/if not samepunkty#w

pX
);defun 








;procedura rysunkowa
(defun rysuje13#w (samepunkty#w a b c d a1 centr nazwa1 
                    / gr seg col pr wskaztu layer szerkol rm c pA pB p0 p1 p2 pX pY pZ styld )

;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
(progn
    ;wskazB - zbir wskaza zmienna globalna
    (setq  wskazB   nil  wskazB   (ssadd)                          
           layer    (getvar "CLAYER")
	   gr	(atoi GrTOPAIR-Sofik#w)
	   seg	(atoi SzerTOPAIR-Sofik#w)
	   col  (atoi ColorTOPAIR-Sofik#w)) 

    (setvar "CLAYER" "0")

    ;;;(setvar "CLAYER" layer_zarys)

    (command "_UCS" "_w")(command "_UCS" "_o" centr)

    (setq pX (trans '(0 0) 1 0)) 

    (command "_PLINE"  (list (+ (/ b 2) gr) (- d)) (list (+ (/ b 2) gr) (+ (/ a1 2) gr))
                       (list (- (+ (/ b 2) gr)) (+ (/ a1 2) gr)) (list (- (+ (/ b 2) gr)) (- d)) "_c")
                       (ssadd (entlast) wskazB)
    (command "_LINE" (list (+ (/ b 2) gr) (- (+ (/ a1 2) gr))) (list (- (+ (/ b 2) gr)) (- (+ (/ a1 2) gr)) ) "")
                     (ssadd (entlast) wskazB)

    (command "_LINE" (list (/ b 2) (- d)) (list (/ b 2) (/ a1 2)) "")
		     (setq pr (entget (entlast)))
	             (setq pr (append pr (list  (cons 62 col) (cons 6 "HIDDEN") )))
		     (entmod pr) (ssadd (entlast) wskazB)

    (command "_LINE" (list (- (/ b 2)) (- d)) (list (- (/ b 2)) (/ a1 2)) "")
		     (setq pr (entget (entlast)))
	             (setq pr (append pr (list  (cons 62 col) (cons 6 "HIDDEN") )))
		     (entmod pr) (ssadd (entlast) wskazB)

    (command "_LINE" (list (- (/ b 2)) (/ a1 2)) (list (/ b 2) (/ a1 2)) "")
		     (setq pr (entget (entlast)))
	             (setq pr (append pr (list  (cons 62 col) (cons 6 "HIDDEN") )))
		     (entmod pr) (ssadd (entlast) wskazB)

    (command "_LINE" (list (- (/ b 2)) (- (/ a1 2))) (list (/ b 2) (- (/ a1 2))) "")
		     (setq pr (entget (entlast)))
	             (setq pr (append pr (list  (cons 62 col) (cons 6 "HIDDEN") )))
		     (entmod pr) (ssadd (entlast) wskazB)

    (if (czy_wzmoc_Ob#w a#w b#w) (progn 
	(command "_UCS" "_o" (list 0 (- d)))(command "_UCS" "_z" "-90")(wzmocnienieObwodowe#w  (list 0 0) -25 b) (command "_UCS" "_p")(command "_UCS" "_p")
				 ));progn/if

         (setq styld (getvar "TEXTSTYLE"))
         (setvar "AFLAGS" 0)
         (command "_ATTDEF" "_p" "" "WENTYLE" "" nazwa1  "_s" styl_wentyle#w
                            "_j" "_bl" (list 0 0) wtext#w "0")
         (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_atrybut#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)  
         (setvar "TEXTSTYLE" styld)
         (command "_UCS" "_p")(command "_UCS" "_p")

(command "_UCS" "_w")(command "_UCS" "_o" pX)
;POINTY - wzgldem pX
(command "_POINT" (list 0 (- d)) )(ssadd (entlast) wskazB)
(command "_UCS" "_p")(command "_UCS" "_p")
(setvar "CLAYER" layer) 

));progn/if not samepunkty#w

pX
);defun 












;druga lokalna procedura sprawdzajca gabaryty wasne, korzysta ze zmiennych procedury nadrzdnej
(defun czy_masterMoj#w ( / gr seg text1#w text2#w pxx#w j#w listaWlasnych_tu#w
			   wlot a b a1 c d aa bb x y p pp ppp skos wylot)
(progn  

;przeniesienie zmiennej procedury nadrzdnej jeli wywoanie z procedury master00#w
(if (not rekord#w)(setq listaWlasnych_tu#w listaWlasnych#w))

(if (and listaWlasnych_tu#w (not text1#w)) (progn
(cond 
((not listaWlas#w)(setq text1#w "Wypenij pola rozmiarw lub wybierz z listy !..."))
(T (progn
   (setq pxx#w '())(foreach j#w listaWlas#w (if (and j#w (/= j#w "")) 
                                                (setq pxx#w (append pxx#w (list j#w)))))
   (if (and listaWlasnych_tu#w (/= (length listaWlasnych_tu#w) (length pxx#w)))
                                (setq text1#w "Brakuje wpisu w jednym z pl rozmiarw !..."))
   ));progn+
);cond
));progn/if

;dla uruchomienia z poziomu procedury dopasowania kanau i zczki
(if rekord#w (setq pxx#w rekord#w listaWlasnych_tu#w T))

	   (setq gr   (atoi GrTOPAIR-Sofik#w)
	   	 seg  (atoi SzerTOPAIR-Sofik#w))

(if (and listaWlasnych_tu#w (not text1#w))
	(progn
        (cond
        ((sprawdz_lcalk#w (nth 0 pxx#w) 100 2400)
              (setq text1#w "Bdny wpis lub przekroczone granice 100 do 2400mm w polu A [mm] !..."))
        ((sprawdz_lcalk#w (nth 1 pxx#w) 100 2400)
              (setq text1#w "Bdny wpis lub przekroczone granice 100 do 2400mm  w polu B [mm] !..."))
        ((sprawdz_lcalk#w (nth 2 pxx#w) 100 2400)
              (setq text1#w "Bdny wpis lub przekroczone granice 100 do 2400mm  w polu A1 [mm] !..."))
        ((sprawdz_lcalk#w (nth 3 pxx#w) 150 10000)
              (setq text1#w "Bdny wpis lub przekroczone granice w polu C [mm] !..."))
        ((sprawdz_lcalk#w (nth 4 pxx#w) 150 10000)
              (setq text1#w "Bdny wpis lub przekroczone granice w polu D [mm] !..."))
	)));progn/if


;sprawdzenie zagbionych rozmiarw 
;text1#w blokuje akcj
;text2#w daje niezobowizujcy komunikat
(if (and listaWlasnych_tu#w (not text1#w))
	(progn
        (setq a (atof (nth 0 pxx#w)) b (atof (nth 1 pxx#w))  a1 (atof (nth 2 pxx#w)) 
 	      c (atof (nth 3 pxx#w)) d (atof (nth 4 pxx#w)) )

    	;;;;;;;;(if (< c d) (setq x (- c 100) y d) (setq x (- d 100) y c))

	;ponisze przypisanie x powoduje nadanie skosowi staej wartoci
	;tutaj 150mm, 
	;uwaga powtrzone w czy_masterMoj#w
	(setq skos 150.0
	      x (+ (/ skos 2) (/ skos (sqrt 2)) gr (/ a 2)))

	(setq p   (* 22.5 (/ pi 180))
	;;;;;;;;     ;;; pp  (* (+ y (/ a 2) gr) (/ (sin p)(cos p)))
	;;;;;;;;      pp  y
	;;;;;;;;      ppp (abs (* 2 (* (- (- x (/ a 2)) gr) (/ (sin p)(cos p)))))
	);setq


    	(if (< c d) (setq wylot c) (setq wylot d))
	(setq wylot (- (- (- wylot (/ a 2)) gr) (/ 150.0 (sqrt 2)))) 

	(setq pp (- (+ seg
		    (/  (+ 150.0 (* (* 2 (+ a (* 2 gr))) (/ (sin p)(cos p)))) (sqrt 2)) ) 
		    (+ (* 0.5 a) gr)) 
	      pp (fix pp))

	(cond
	;najpierw okrela tu text1#w potem text2#w

	((>= a1 a)(setq text1#w "A1 powinno by mniejsze od A !..."))
	((> (+ c 50) pp)(setq text1#w "Najwiksza dugo segmentu wylotu nie moe przekroczy 1170 mm !..."))
	((> (+ d 50) pp)(setq text1#w "Najwiksza dugo segmentu wylotu nie moe przekroczy 1170 mm !..."))

	((< wylot 30.0)(setq text1#w "Najmniejsza dugo wylotu nie moe by mniejsza od 30 mm !..."))

	((< wylot 100.0)(setq text2#w "Niewskazane - Najmniejsza dugo wylotu jest mniejsza od 100 mm !..."))

	;;;;;;;((< ppp 150.0)(setq text2#w "Niewskazane - Najmniejsza dugo skosu jest mniejsza od 150 mm !..."))

        );cond
	));progn/if

(if text2#w (alert text2#w))

(if (not rekord#w) (if text1#w (set_tile "error" text1#w)))
text1#w

));progn/defun



		;procedura oblicza wartoci wymiarw mniej wanych dla potrzeb procedury master...
		;wykorzystuje i generuje zmienne tej nadrzdnej procedury					
		(defun przeliczTuTu#w ( control#w / a#w b#w)
		(cond
		((= control#w 1)(progn
			  (setq a#w (atof wlasne0_tu#w)
				b#w (atof wlasne1_tu#w))
			  (setq wlasne3_tu#w (rtos (+ (/ a#w 2) 250.0) 2 0) ;C mm
				wlasne4_tu#w (rtos (+ (/ a#w 2) 250.0) 2 0) ;D mm
			  );setq
			));progn+

		(T (progn (setq wlasne2_tu#w "" ;C mm
				wlasne3_tu#w "" ;D mm
			  );setq
			));progn+
		);cond
		(princ)
		);defun
