;------------------------------------------------------------------
;procedura gwna obliczajca spadki cinie elementw jednego typu
;ELEMENT (jednokierunkowy) W KTRYM dPa ZALENE od innego parametru ni kierunek

(defun obliczPa#w ( sciezkaPlik#w plik#w jm#w jm_wsp#w wszystkieKierPa#w listaDoPa#w / 
                    obi#w rozmiar#w kierunki#w rozmiar#w i#w j#w zwrot#w zwrotObi#w kiery#w
		    figura#w akcesoria#w parametr#w 
		    dane600-1#w dane600-2#w dane600-3#w dane600-4#w 
		    dane900-1#w dane900-2#w dane900-3#w dane900-4#w 
		    dane1200-1#w dane1200-2#w dane1200-3#w dane1200-4#w
		    dane1500-1#w dane1500-2#w dane1500-3#w dane1500-4#w dane#w ) 

;jm#w       "_cm#w"
;jm_wsp#w   "0.1"
;zmienna przenoszca razem wykryte kierunki we wszystkich obiektach tego typu
;  wszystkieKierPa#w np.(("P1>P3" "P1>P2")("P1>P2" "P1>P3"))
;po rozpakowaniu listy listaDoPa#w tworzy z jej rekordu:
;  obi#w
;  rozmiar#w  ("d1mm" "150") ("d3mm" "400") ("Lmm" "140") ("Hmm" "87") ("kgTCPL" "0.5") 
;  kierunki#w (("P1" "d1mm" "200.00" (144.929 64.6729 0.0) "P3" "d3mm" "100.00" (151.929 73.3729 0.0)) 
;              ("P1" "d1mm" "200.00" (144.929 64.6729 0.0) "P2" "d1mm" "100.00" (158.929 64.6729 0.0)))
;  kiery#w    (("P3>P1" "P2>P1") ("P2>P1" "P3>P1")) - ju po podwojeniu-odwrceniu poniej
;  dalsze nie w kadym elemencie potrzebne:
;  figura#w   "12"
;  akcesoria#w (("" "")) lub (("WentyleSpiroRGS_akcesoria" "2")("WentyleSpiroRGS_lamelki" "1")
;                             ("WentyleSpiroRGS_przepustnica" "0"))


;rekonstrukcja wszystkieKierPa#w poniewa na wybr wykresu ma wpyw inna wielko 
;ni kierunki przepywu
(setq wszystkieKierPa#w '())
(foreach i#w listaDoPa#w (setq wszystkieKierPa#w 
                         (append wszystkieKierPa#w (list (cadar (cadr i#w))))))

;zaadowanie danych pod odpowiednie zmienne
(foreach i#w wszystkieKierPa#w
(cond

;600-1
((and (not dane600-1#w)(= i#w "600-1"))
     (progn (load (strcat sciezkaPlik#w plik#w "_600-1.lsp"))
            (setq dane600-1#w (obliczPa1#w)) ))
;600-2
((and (not dane600-2#w)(= i#w "600-2"))
     (progn (load (strcat sciezkaPlik#w plik#w "_600-2.lsp"))
            (setq dane600-2#w (obliczPa1#w)) ))
;600-3
((and (not dane600-3#w)(= i#w "600-3"))
     (progn (load (strcat sciezkaPlik#w plik#w "_600-3.lsp"))
            (setq dane600-3#w (obliczPa1#w)) ))
;600-4
((and (not dane600-4#w)(= i#w "600-4"))
     (progn (load (strcat sciezkaPlik#w plik#w "_600-4.lsp"))
            (setq dane600-4#w (obliczPa1#w)) ))

;900-1
((and (not dane900-1#w)(= i#w "900-1"))
     (progn (load (strcat sciezkaPlik#w plik#w "_900-1.lsp"))
            (setq dane900-1#w (obliczPa1#w)) ))
;900-2
((and (not dane900-2#w)(= i#w "900-2"))
     (progn (load (strcat sciezkaPlik#w plik#w "_900-2.lsp"))
            (setq dane900-2#w (obliczPa1#w)) ))
;900-3
((and (not dane900-3#w)(= i#w "900-3"))
     (progn (load (strcat sciezkaPlik#w plik#w "_900-3.lsp"))
            (setq dane900-3#w (obliczPa1#w)) ))
;900-4
((and (not dane900-4#w)(= i#w "900-4"))
     (progn (load (strcat sciezkaPlik#w plik#w "_900-4.lsp"))
            (setq dane900-4#w (obliczPa1#w)) ))

;1200-1
((and (not dane1200-1#w)(= i#w "1200-1"))
     (progn (load (strcat sciezkaPlik#w plik#w "_1200-1.lsp"))
            (setq dane1200-1#w (obliczPa1#w)) ))
;1200-2
((and (not dane1200-2#w)(= i#w "1200-2"))
     (progn (load (strcat sciezkaPlik#w plik#w "_1200-2.lsp"))
            (setq dane1200-2#w (obliczPa1#w)) ))
;1200-3
((and (not dane1200-3#w)(= i#w "1200-3"))
     (progn (load (strcat sciezkaPlik#w plik#w "_1200-3.lsp"))
            (setq dane1200-3#w (obliczPa1#w)) ))
;1200-4
((and (not dane1200-4#w)(= i#w "1200-4"))
     (progn (load (strcat sciezkaPlik#w plik#w "_1200-4.lsp"))
            (setq dane1200-4#w (obliczPa1#w)) ))

;1500-1
((and (not dane1500-1#w)(= i#w "1500-1"))
     (progn (load (strcat sciezkaPlik#w plik#w "_1500-1.lsp"))
            (setq dane1500-1#w (obliczPa1#w)) ))
;1500-2
((and (not dane1500-2#w)(= i#w "1500-2"))
     (progn (load (strcat sciezkaPlik#w plik#w "_1500-2.lsp"))
            (setq dane1500-2#w (obliczPa1#w)) ))
;1500-3
((and (not dane1500-3#w)(= i#w "1500-3"))
     (progn (load (strcat sciezkaPlik#w plik#w "_1500-3.lsp"))
            (setq dane1500-3#w (obliczPa1#w)) ))
;1500-4
((and (not dane1500-4#w)(= i#w "1500-4"))
     (progn (load (strcat sciezkaPlik#w plik#w "_1500-4.lsp"))
            (setq dane1500-4#w (obliczPa1#w)) ))

));cond/foreach


;obliczenie spadku cinienia na elemencie
(setq zwrot#w '())

(foreach i#w listaDoPa#w
(progn  (setq obi#w (handent (car i#w))
              kiery#w     (caddr i#w)
	      rozmiar#w   (cadr i#w) 
              parametr#w  (cadar rozmiar#w)
 	      kierunki#w  (cadddr i#w)
	      akcesoria#w (cadr (cddddr i#w)) )

	(setq zwrotObi#w '())
	(cond

	;600-1
	((= parametr#w "600-1") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane600-1#w ) 
                             )))))
	;600-2
	((= parametr#w "600-2") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane600-2#w ) 
                             )))))
	;600-3
	((= parametr#w "600-3") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane600-3#w ) 
                             )))))
	;600-4
	((= parametr#w "600-4") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane600-4#w ) 
                             )))))
	;900-1
	((= parametr#w "900-1") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane900-1#w ) 
                             )))))
	;900-2
	((= parametr#w "900-2") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane900-2#w ) 
                             )))))
	;900-3
	((= parametr#w "900-3") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane900-3#w ) 
                             )))))
	;900-4
	((= parametr#w "900-4") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane900-4#w ) 
                             )))))
	;1200-1
	((= parametr#w "1200-1") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane1200-1#w ) 
                             )))))
	;1200-2
	((= parametr#w "1200-2") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane1200-2#w ) 
                             )))))
	;1200-3
	((= parametr#w "1200-3") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane1200-3#w ) 
                             )))))
	;1200-4
	((= parametr#w "1200-4") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane1200-4#w ) 
                             )))))
	;1500-1
	((= parametr#w "1500-1") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane1500-1#w ) 
                             )))))
	;1500-2
	((= parametr#w "1500-2") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane1500-2#w ) 
                             )))))
	;1500-3
	((= parametr#w "1500-3") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane1500-3#w ) 
                             )))))
	;1500-4
	((= parametr#w "1500-4") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane1500-4#w ) 
                             )))))

	;inne - nieliczone rozmiary
	( T                  (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
					akcesoria#w nil ) 
                             )))))
	);cond

        (if zwrotObi#w (setq zwrotObi#w (append (list obi#w) zwrotObi#w)))

(if zwrotObi#w (setq zwrot#w (append zwrot#w (list zwrotObi#w))))
));progn/foreach i#w

;zwrot#w ((<Entity name: 2792a90> (("P1>P2") "35" "0;Przekroczony zasig danych o 
;          spadkach!") (("P2>P1") "35" "0;Przekroczony zasig danych o spadkach!")) 
;         (<Entity name: 2792cc8> (("P2>P1") "35" "0;Przekroczony zasig danych o 
;          spadkach!") (("P2>P1") "35" "0;Przekroczony zasig danych o spadkach!")))
zwrot#w
);defun











;podprocedura porednia obliczeniowa spadkw cinie jednego kierunku jednego elementu
(defun liczyPa#w ( i#w rozmiar#w kierunki#w parametr#w akcesoria#w dane#w /
		   nastawa#w nastawa1#w p#w d#w f#w text#w wyd#w zwrot#w kierTu#w )

;i#w ("P2>P1")
;rozmiar#w (("Wielko" "600-1") ("d2mm" "100") ("d1mm" "125") ("Lmm" "320") ("Bmm" "320") ("Hmm" "170") ("Amm" "210"))
;kierunki#w (("P1" "d1mm" "600.00" (-348.838 176.616 0.0) "P2" "d1mm" "600.00" (-348.838 179.356 0.0)))
;dane#w (("0" "10" "50")...)
;parametr#w "600-1"
;akcesoria#w (("WentyleFlaktbRH1_Nastawy" "1")...)


(if (not dane#w)
    (setq zwrot#w (list "" (strcat "0;Brak danych o spadkach cinie dla rozmiaru " parametr#w) ))

;else - jeli rozmiar uzbrojony w liczenie dPa
(progn

(setq nastawa#w (cadar akcesoria#w))	

		(cond ((member nastawa#w '("0"))  (setq nastawa1#w "otw.100%"))
		      ((member nastawa#w '("1"))  (setq nastawa1#w "otw.80%"))
		      ((member nastawa#w '("2"))  (setq nastawa1#w "otw.60%"))
		      ((member nastawa#w '("3"))  (setq nastawa1#w "otw.40%"))
		      ((member nastawa#w '("4"))  (setq nastawa1#w "otw.20%"))
		      ((member nastawa#w '("5"))  (setq nastawa1#w "otw.0%"))
		);cond

(setq kierTu#w (car kierunki#w))

               ;wymiar>przekrj
		(setq p#w  (nth 1 kierTu#w)
                      d#w  p#w)
		(setq d#w  (/ (atof (cadr (assoc d#w rozmiar#w))) 1000.0) ;[m]
		      f#w  (/ (* pi (* d#w d#w)) 4))  ;[m2]
		(setq text#w (strcat "0;Nawiewnik," nastawa1#w))

(setq wyd#w (atof (nth 2 kierTu#w)) ) ;[m3/h]
(setq wyd#w (/ wyd#w 3.6)) ;[l/s]

;wywoanie odczytu dPa z tablicy/wykresu
;(Nastawa, Wyd[l/s], DPa[Pa])
(setq zwrot#w (LiczyPa_odczytDPa#w (itoa (- 100 (* (atoi nastawa#w) 20))) (rtos wyd#w 2 12) dane#w))

(if (and text#w (= (cadr zwrot#w) "")) (setq zwrot#w (list (car zwrot#w) text#w)))

));progn-else/if parametr#w

zwrot#w   ;'("35" "Trjn.przelot") lub np. '("" "0;Przekroczony zakres na wykresie spadkw ci.") 
);defun 






