;-----------------------------------------------------
;procedura zarzadzajca tworzeniem/wstawianiem obiektu
(defun runn#w ( czyedycja#w / zwrot#w ktora#w rekord#w czyuszczelka#w centr#w blok#w nazwa#w
                  nazwadoz#w ppzwrot#w pX#w tblist#w tdata#w samepunkty#w kanal#w

		 typ#w ilb#w d1#w d#w  h#w b1#w b2#w b3#w dd#w    wer#w
		  akcesoria#w  blokOpisUwagi#w  listaPX#w i#w p#w pp#w sciezkaB#w) 

		;lokalna konfiguruje opis tu i w master00#w
		(defun blokOpisUwagi#w ( rekord#w akcesoria#w / blok#w nazwadoz#w
						  lamelAtryb#w  rozmiarAtryb#w)
		(setq  blok#w     "LABB"
		       nazwadoz#w "LABB-")
                ;Typ
;;;uwzgldnienie wersji 
		(setq pp#w (cadr (assoc "WentyleHarmannLAB_WERSJA" akcesoria#w)))
		(cond ((member pp#w '("0"))  (setq wer#w "F"))	
		      ((member pp#w '("1"))  (setq wer#w "C"))		      
		);cond

		  
		(setq  ppp#w (car rekord#w))
		(setq  blok#w     (strcat blok#w wer#w (substr ppp#w 6)  "XX" )
		       nazwadoz#w (strcat nazwadoz#w wer#w "-" (substr ppp#w 6) ))


	             ;blok   nazwa      tytul  uwagi         producent
		(list blok#w nazwadoz#w "Wentylator chemoodporny" ""  "Harmann"  
		      lamelAtryb#w  rozmiarAtryb#w)
		);defun

(wl_err1#w)
;pobiera daNE o elemencie
(setq zwrot#w
(master00#w "WentyleHarmann" "Wentylator chemoodporny " "WentyleHarmannLAB" "LABB" "Harmann" " "   "    " 
            "Okno_plus_hm" czyedycja#w "" nil "0"
            "WentyleHarmann(LAB)" "WentyleHarmann(LAB_11)" "WentyleHarmann(LAB_12)" nil  nil
                                    nil nil nil nil
             (list (list "Wersja:" "WentyleHarmannLAB_WERSJA") ) ;listaPlikowDanychWyposaenia
	     nil ;listaWlasnychGabarytw z opisami
));master00#w/setq
(wyl_err1#w)


(if zwrot#w  
(progn 			

(wl_err1#w)
;przygotowanie danych dla rysunku bloku i do stworzenia bloku
;;; typ#w ilb#w d1#w d#w  h#w b1#w b2#w b3#w dd#w   
(setq   rekord#w (nth 5 zwrot#w)
	typ#w  (nth 0 rekord#w)
	ilb#w (atof (nth 1 rekord#w))
	d1#w (atof (nth 2 rekord#w))
	d#w  (atof (nth 3 rekord#w))
	h#w (atof (nth 4 rekord#w))
	b1#w (atof (nth 5 rekord#w))
	b2#w (atof (nth 6 rekord#w))
	b3#w  (atof (nth 7 rekord#w))
	dd#w (atof (nth 8 rekord#w))



  czyuszczelka#w (nth 15 zwrot#w)
         centr#w (nth 14 zwrot#w) 
         nazwa#w (strcat (car (nth 12 zwrot#w)) (nth 13 zwrot#w) )
         ktora#w (nth  6 zwrot#w)
     akcesoria#w (nth 16 zwrot#w)
	trata (nth 16 zwrot#w))

;;;uwzgldnienie wersji 
		(setq ppio#w (cadr (assoc "WentyleHarmannLAB_WERSJA" akcesoria#w)))
		(cond ((member ppio#w '("0"))  (setq wer#w "F"))	
		      ((member ppio#w '("1"))  (setq wer#w "C"))		      
		);cond
   (if (member wer#w '("C"))
     (progn
      (cond
       ((= d1#w 110)(setq h#w 510))
       ((= d1#w 125)(setq h#w 570))
       ((= d1#w 160)(setq h#w 780))
       ((= d1#w 200)(setq h#w 885))
       ((= d1#w 250)(setq h#w 930))
     )
     )
   )

   (setq p#w        (blokOpisUwagi#w rekord#w akcesoria#w)
         blok#w     (car p#w)
         nazwadoz#w (cadr p#w))


	   	(setq sciezkaB#w (strcat scd#w (caar zwrot#w) "\\"   typ#w  "_" ktora#w ))
	       

                                     ;lamelAtryb#w rozmiarAtryb#w
   (setq nazwadoz#w (list nazwadoz#w (nth 5 p#w)   (nth 6 p#w) ))

   (setq blok#w (strcase (strcat blok#w "_" ktora#w)))

(setq tblist#w '())
(while (setq tdata#w (tblnext "BLOCK" (not tdata#w)))
(setq tblist#w (append tblist#w (list (cdr (assoc 2 tdata#w))))))

;jesli nie samepunkty - narysowanie bloku, else - zwraca wsprzdne samych punktw
(if (not (member blok#w tblist#w)) 
	    (setq samepunkty#w nil)
	    ;else
	    (setq samepunkty#w T))

;tworzy rysunek bloku lub same wsprzdne punktw styku
(cond
((= ktora#w "11")(setq ppzwrot#w (rys11#w samepunkty#w sciezkaB#w typ#w ilb#w d1#w d#w  h#w b1#w b2#w b3#w dd#w wer#w centr#w czyuszczelka#w nazwa#w)))
((= ktora#w "12")(setq ppzwrot#w (rys12#w samepunkty#w sciezkaB#w typ#w ilb#w d1#w d#w  h#w b1#w b2#w b3#w dd#w wer#w centr#w czyuszczelka#w nazwa#w)))


);cond



;************************
;dodanie pola przekroju do kadego punktu z ppzwrot#w
(setq pp#w '())
(foreach i#w (cddr ppzwrot#w)
(cond
((equal (list (car i#w) (cadr i#w)) '("P1" "d1mm"))
        (setq p#w  (/ (/ (* pi (* d1#w d1#w)) 4) 1000000.0)     ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
((equal (list (car i#w) (cadr i#w)) '("P2" "d1mm"))
        (setq p#w  (/ (/ (* pi (* d1#w d1#w)) 4) 1000000.0)     ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
));cond/foreach i#w
(if (and pp#w (= (length pp#w) (- (length ppzwrot#w) 2)))
    (setq ppzwrot#w (list (car ppzwrot#w) (cadr ppzwrot#w))
          ppzwrot#w (append ppzwrot#w  pp#w)))
;************************

;jesli nie samepunkty - tworzy blok
(blokuje00#w samepunkty#w blok#w ppzwrot#w zwrot#w)

(wyl_err1#w)

(if czyedycja#w (progn
		;odczytuje punkty PX dopisdopisane ew.wczeniej do edytowanego
		(setq listaPX#w (doprzeniesieniaPX#w (car czyedycja#w)))
		;wstawia blok
		(insert01#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w 
		           (cadr czyedycja#w) (caddr czyedycja#w) czyedycja#w nil)
		;dopisuje wczeniej odczytane PX
		(if listaPX#w (zprzeniesienia#w (entlast) listaPX#w))
		);progn
	;else
	(progn

	;wstawia blok
	(insert00#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w nil)

	;ustawia zmienne globalne
	(globset00#w zwrot#w)

		;export do pliku danych wsplnych nakadki
		(dotxt#w "Wentyle")

		;export do pliku danych tego systemu zczek
		(dotxt00#w "WentyleHarmann")


	;rysuje odnonik
	(cond ((= strzal#w "1") (odno_strzalka#w))
	      ( T               (odno_linia#w))  )

	));progn/if not czyedycja

));progn/if
		
(princ)
);defun





;procedura porednia rysunkowa
(defun rys11#w (samepunkty#w sciezkaB#w  typ#w ilb#w d1#w d#w  h#w b1#w b2#w b3#w dd#w wer#w  centr#w czyuszczelka#w nazwa#w / pX#w p00#w) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje11#w samepunkty#w sciezkaB#w  typ#w ilb#w d1#w d#w  h#w b1#w b2#w b3#w dd#w wer#w   centr#w czyuszczelka#w nazwa#w))
    ));progn/if

;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                   ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "d1mm" (list 0 0)   "");dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P1" "d1mm" (list 0 0)   "");dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "d1mm" (list 0 h#w) "")
));list/setq

ppzwrot#w
);defun





;procedura porednia rysunkowa
(defun rys12#w (samepunkty#w sciezkaB#w  typ#w ilb#w d1#w d#w  h#w b1#w b2#w b3#w dd#w wer#w centr#w czyuszczelka#w nazwa#w / pX#w p00#w) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje12#w samepunkty#w sciezkaB#w typ#w ilb#w d1#w d#w  h#w b1#w b2#w b3#w dd#w wer#w  centr#w czyuszczelka#w nazwa#w))
    ));progn/if

;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                   ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest" (list 0 0)         "") ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "d1mm" (list 0 0)   "");dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "d1mm" (list (- (* 0.55 dd#w)) 0) "")
));list/setq

ppzwrot#w
);defun





;procedura rysunkowa
(defun rysuje11#w (samepunkty#w sciezkaB#w typ ilb d1 d  h b1 b2 b3 dd wer centr czyuszczelka nazwa1 
                    / pr l1 wskaztu layer szerkol odstep rm pA pB p0 p1 p11  p2 p21 pX pY pZ styld  ods ldz krc mdd h1 h2 h3 h4 szw)


;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
(progn
    ;wskazB - zbir wskaza zmienna globalna
    (setq  wskazB   nil  wskazB   (ssadd)                       
           layer    (getvar "CLAYER")
	   
	   )    

    (command "_LAYER" "_t" "0" "_s" "0" "")

    (command "_UCS" "_w")(command "_UCS" "_o" centr)

    (setq  pX  (trans (list 0 0) 1 0)
 	   krc 30
	   mdd (* 0.4 dd)
	   h1 (* 0.35 h)
	   h2 (* 0.05 h)
	   h3 (* 0.6 h)
	   h4 (* 0.8 h)
	   szw (* 0.35 dd)
    );setq

(if (member wer '("F"))
  (progn
     (if (= d1 110)
       (progn
         (command "_pline" (list (- (+ krc (* 0.55 d1))) krc)(list (- (+ krc (* 0.55 d1))) 0)(list (+ krc (* 0.55 d1)) 0)(list (+ krc (* 0.55 d1)) krc) "")(ssadd (entlast) wskazB)
         (command "_line" (list (- (* 0.5 d1)) 0)(list (- (+ krc (* 0.5 d1))) krc) "")
	  (setq pr (entget (entlast)))(setq pr (append pr (list  (cons 6 "HIDDEN") )))(entmod pr)(ssadd (entlast) wskazB)
          (command "_mirror" (entlast) "" (list 0 0)(list 0 100) "")  (ssadd (entlast) wskazB)
          (command "_pline" (list (- mdd) h1)(list (- mdd) krc)(list  mdd krc)(list  mdd h1) "")(ssadd (entlast) wskazB)
          (command "_line" (list (- mdd) (* 0.3 h1))(list mdd (* 0.3 h1)) "")(ssadd (entlast) wskazB)
 
       )      
       (progn
	 (command "_pline" (list (- mdd) h1)(list (- (* 0.5 d)) 0)(list (* 0.5 d) 0)(list  mdd h1)"")(ssadd (entlast) wskazB)
         (command "_pline" (list (- (* 0.5 d1)) 0)(list (-  (* 0.5 d1)) krc) (list (* 0.5 d1) krc)(list  (* 0.5 d1) 0)"")
	  (setq pr (entget (entlast)))(setq pr (append pr (list  (cons 6 "HIDDEN") )))(entmod pr)(ssadd (entlast) wskazB)
       )
     );;;if typ c/f
     (command "_pline" (list (- (* 0.5 dd)) h1)(list (* 0.5 dd) h1)(list (* 0.5 dd) (+ h1 h2))(list (- (* 0.5 dd)) (+ h1 h2))"_c")(ssadd (entlast) wskazB)
     (command "_line" (list (- (* 0.5 dd)) (+ h1 (* 0.5 h2)))(list (* 0.5 dd) (+ h1 (* 0.5 h2)))"")(ssadd (entlast) wskazB)
    (command "_pline" (list (- (* 0.5 szw)) (+ h1 h2))(list (- (* 0.5 szw)) (- h (* 0.5 szw))) "_a"(list  (* 0.5 szw) (- h (* 0.5 szw))) "_l"
                      (list  (* 0.5 szw) (+ h1 h2)) "")(ssadd (entlast) wskazB)
    (command "_pline" (list (* 0.35 szw) (- h (* 0.6 szw))) (list (* 0.35 szw) (- h (* 0.5 szw))) "_a" (list  (- (* 0.35 szw)) (- h (* 0.5 szw))) "_l" (list (- (* 0.35 szw)) (- h (* 0.6 szw)))
	     "_c")(ssadd (entlast) wskazB)
    (command "_line" (list (- (* 0.5 szw)) (+ h1 (* 2 h2)))(list  (* 0.5 szw) (+ h1 (* 2 h2)))"")(ssadd (entlast) wskazB)
    (command "_line" (list (- (* 0.5 szw)) (- h (* 0.75 szw))) (list (* 0.5 szw) (- h (* 0.75 szw)))"")(ssadd (entlast) wskazB)
    (command "_circle" (list 0 h3)(* 0.35 szw))(ssadd (entlast) wskazB)
    (command "_line" (list (- (* 0.4 szw)) h3)(list (* 0.4 szw) h3)"")(ssadd (entlast) wskazB)
    (command "_pline" (list mdd (+ h1 h2))(list mdd h4)(list (* 0.5 szw) h4)"")(ssadd (entlast) wskazB)
     (command "_mirror" (entlast) "" (list 0 0)(list 0 100) "")  (ssadd (entlast) wskazB)

    
       (command "_pline" (list mdd h4)(list (* 0.5 dd) h4 )(list (* 0.5 dd) (+ h4 (* 1 h2)))(list (* 0.5 szw) (+ h4 (* 1 h2)))"")(ssadd (entlast) wskazB)
      (command "_mirror" (entlast) "" (list 0 0)(list 0 100) "")  (ssadd (entlast) wskazB)
    (command  "_pline" (list (* 0.5 dd) (+ h4 (* 0.5 h2)))(list (* 0.5 szw) (+ h4 (* 0.5 h2)))"")  (ssadd (entlast) wskazB)
    (command "_mirror" (entlast) "" (list 0 0)(list 0 100) "")  (ssadd (entlast) wskazB)
     (command "_pline" (list mdd (+ h4  h2))(list (* 0.55 d1) h)(list (- (* 0.55 d1)) h)(list (- mdd) (+ h4  h2))"")  (ssadd (entlast) wskazB)

  )
 (progn
    (setq
      	   h1 (* 0.25 h)
	   h2 (* 0.05 h)
	   h3 (* 0.48 h)
	   h4 (* 0.6 h)
	   hh (* 0.75 h)
    )
   
     (if (= d1 110)
       (progn
         (command "_pline" (list (- (+ krc (* 0.55 d1))) krc)(list (- (+ krc (* 0.55 d1))) 0)(list (+ krc (* 0.55 d1)) 0)(list (+ krc (* 0.55 d1)) krc) "")(ssadd (entlast) wskazB)
         (command "_line" (list (- (* 0.5 d1)) 0)(list (- (+ krc (* 0.5 d1))) krc) "")
	  (setq pr (entget (entlast)))(setq pr (append pr (list  (cons 6 "HIDDEN") )))(entmod pr)(ssadd (entlast) wskazB)
          (command "_mirror" (entlast) "" (list 0 0)(list 0 100) "")  (ssadd (entlast) wskazB)
         (command "_pline" (list (- mdd) h1)(list (- mdd) krc)(list  mdd krc)(list  mdd h1) "")(ssadd (entlast) wskazB)
          (command "_line" (list (- mdd) (* 0.3 h1))(list mdd (* 0.3 h1)) "")(ssadd (entlast) wskazB)
 
       )      
       (progn
	 (command "_pline" (list (- mdd) h1)(list (- (* 0.5 d)) 0)(list (* 0.5 d) 0)(list  mdd h1)"")(ssadd (entlast) wskazB)
         (command "_pline" (list (- (* 0.5 d1)) 0)(list (-  (* 0.5 d1)) krc) (list (* 0.5 d1) krc)(list  (* 0.5 d1) 0)"")
	  (setq pr (entget (entlast)))(setq pr (append pr (list  (cons 6 "HIDDEN") )))(entmod pr)(ssadd (entlast) wskazB)
;;;          (command "_mirror" (entlast) "" (list 0 0)(list 0 100) "")  (ssadd (entlast) wskazB)	 
       )
     );;;if typ c/f
     (command "_pline" (list (- (* 0.5 dd)) h1)(list (* 0.5 dd) h1)(list (* 0.5 dd) (+ h1 h2))(list (- (* 0.5 dd)) (+ h1 h2))"_c")(ssadd (entlast) wskazB)
     (command "_line" (list (- (* 0.5 dd)) (+ h1 (* 0.5 h2)))(list (* 0.5 dd) (+ h1 (* 0.5 h2)))"")(ssadd (entlast) wskazB)
    (command "_pline" (list (- (* 0.5 szw)) (+ h1 h2))(list (- (* 0.5 szw)) (- hh (* 0.5 szw))) "_a"(list  (* 0.5 szw) (- hh (* 0.5 szw))) "_l"
                      (list  (* 0.5 szw) (+ h1 h2)) "")(ssadd (entlast) wskazB)
    (command "_pline" (list (* 0.35 szw) (- hh (* 0.6 szw))) (list (* 0.35 szw) (- hh (* 0.5 szw))) "_a" (list  (- (* 0.35 szw)) (- hh (* 0.5 szw))) "_l" (list (- (* 0.35 szw)) (- hh (* 0.6 szw)))
	     "_c")(ssadd (entlast) wskazB)
    (command "_line" (list (- (* 0.5 szw)) (+ h1 (* 2 h2)))(list  (* 0.5 szw) (+ h1 (* 2 h2)))"")(ssadd (entlast) wskazB)
    (command "_line" (list (- (* 0.5 szw)) (- hh (* 0.75 szw))) (list (* 0.5 szw) (- hh (* 0.75 szw)))"")(ssadd (entlast) wskazB)
    (command "_circle" (list 0 h3)(* 0.35 szw))(ssadd (entlast) wskazB)
    (command "_line" (list (- (* 0.4 szw)) h3)(list (* 0.4 szw) h3)"")(ssadd (entlast) wskazB)
    (command "_pline" (list mdd (+ h1 h2))(list mdd h4)(list (* 0.5 szw) h4)"")(ssadd (entlast) wskazB)
     (command "_mirror" (entlast) "" (list 0 0)(list 0 100) "")  (ssadd (entlast) wskazB)

    
       (command "_pline" (list mdd h4)(list (* 0.5 dd) h4 )(list (* 0.5 dd) (+ h4 (* 1 h2)))(list (* 0.5 szw) (+ h4 (* 1 h2)))"")(ssadd (entlast) wskazB)
      (command "_mirror" (entlast) "" (list 0 0)(list 0 100) "")  (ssadd (entlast) wskazB)
    (command  "_pline" (list (* 0.5 dd) (+ h4 (* 0.5 h2)))(list (* 0.5 szw) (+ h4 (* 0.5 h2)))"")  (ssadd (entlast) wskazB)
    (command "_mirror" (entlast) "" (list 0 0)(list 0 100) "")  (ssadd (entlast) wskazB)

    (command "_pline" (list mdd (+ h4  h2))(list mdd hh)(list (* 0.5 d1) (- h 40))(list (* 0.5 d1) h)(list (- (* 0.5 d1)) h)(list (- (* 0.5 d1)) (- h 40))(list (- mdd) hh)(list (- mdd) (+ h4  h2))"")  (ssadd (entlast) wskazB)
    (command "_line" (list (* 0.5 d1) (- h 40))(list (- (* 0.5 d1)) (- h 40))"")  (ssadd (entlast) wskazB)
    (command "_line" (list mdd hh)(list (- mdd) hh)"")  (ssadd (entlast) wskazB)
	     
   
;;;     (command "_pline" (list mdd (+ h4  h2))(list (* 0.55 d1) h)(list (- (* 0.55 d1)) h)(list (- mdd) (+ h4  h2))"")  (ssadd (entlast) wskazB)
  )
 )



  

    (command "_LINE" (list 0 0)(list 0 h) "")
    (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_osie#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)


         (setq styld (getvar "TEXTSTYLE"))
         (setvar "AFLAGS" 0)
         (command "_ATTDEF" "_p" "" "WENTYLE" "" nazwa1  "_s" styl_wentyle#w
                            "_j" "_bl" (list 0 0) wtext#w "0")
         (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_atrybut#w)(assoc 8 pr) pr))(entmod pr)
                                                              (ssadd (entlast) wskazB)  
         (command "_-STYLE" styld "" "" "" "" "" "" "")
         (command "_UCS" "_p")(command "_UCS" "_p")

(command "_UCS" "_w")(command "_UCS" "_o" pX)
;POINTY - wzgldem pX

(command "_POINT" (list 0 0) )(ssadd (entlast) wskazB)
(command "_POINT" (list 0 h) )(ssadd (entlast) wskazB)

(command "_UCS" "_p")(command "_UCS" "_p")
(command "_LAYER" "_s" layer "") 

));progn/if not samepunkty#w


pX
);defun 








;procedura rysunkowa
(defun rysuje12#w (samepunkty#w sciezkaB#w typ ilb d1 d  h b1 b2 b3 dd wer centr czyuszczelka nazwa1 
                    / pr l0 l1 l2 l3 wskaztu layer szerkol odstep rm pA pB p0 p1 p11  p2 p21 pX pY pZ styld  ods ldz krc mdd h1 h2 h3 h4 szw
		   bm z5 z6  en er1 er2 er3 skok alfb alf2 alf3)

;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
(progn
    ;wskazB - zbir wskaza zmienna globalna
    (setq  wskazB   nil  wskazB (ssadd)                 
           layer    (getvar "CLAYER")
	   )    

    (command "_LAYER" "_t" "0" "_s" "0" "")

    (command "_UCS" "_w")(command "_UCS" "_o" centr)
     (setq  pX  (trans (list 0 0) 1 0)
	   mdd (* 0.4 dd)
	   h1 (* 0.35 h)
	   h2 (* 0.05 h)
	   h3 (* 0.6 h)
	   h4 (* 0.8 h)
	   szw (* 0.35 dd)
	   er1 (* 0.5 d1)
	   er2 (* 0.65 mdd)  
	   er3 (* 0.95 mdd)
	   en 18
	   skok (/ pi (/ en 2))
	   alfb 0
	   alf2 (* 45 (/ pi 180))
	   alf3 (* 90 (/ pi 180))
    );setq


     (if (= wer "F")
       (progn

	  (command "_CIRCLE" (list 0 0) (* 0.35 d1))(ssadd (entlast) wskazB)
	  (command "_CIRCLE" (list 0 0) (* 0.5 d1))(ssadd (entlast) wskazB)
	 
        (repeat en
	  (progn
	    (setq p3 (polar (list 0 0) alfb er3)
		  p2 (polar (list 0 0) (+ alfb alf2) er2)
		  p1 (polar (list 0 0) (+ alfb alf3) er1)
	    )
	    (command "_arc" p3 p2 p1)(ssadd (entlast) wskazB)

	    (setq alfb (+ alfb skok))
	  )
	)

	 
       )
       (progn
	 (command "_CIRCLE" (list 0 0) (* 0.5 d1))(ssadd (entlast) wskazB)
	 (command "_CIRCLE" (list 0 0) mdd)(ssadd (entlast) wskazB)
	 
       )
     );;;if typ c/f
 

	  (command "_line" (list (- (* 0.5 szw)) (* 0.5 dd))(list (* 0.5 szw)(* 0.5 dd))"")(ssadd (entlast) wskazB)
	 (command "_pline" (list (- (* 0.5 szw)) (- (* 0.5 dd)))(list (* 0.5 szw)(-(* 0.5 dd)))(list (* 0.5 szw)(- (- b3 (* 0.5 dd))))
		  (list (- (* 0.5 szw))(- (- b3 (* 0.5 dd)))) "_c")(ssadd (entlast) wskazB)
  
    (command "_CIRCLE" (list 0 0) (* 0.5 dd))(ssadd (entlast) wskazB)
  
    (command "_LINE" (list (- (* 0.55 dd)) 0)(list (* 0.55 dd) 0) "")
    (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_osie#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)

    (command "_LINE" (list 0 (- (* 0.55 dd)) )(list 0 (* 0.55 dd) ) "")
    (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_osie#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)




         (setq styld (getvar "TEXTSTYLE"))
         (setvar "AFLAGS" 0)
         (command "_ATTDEF" "_p" "" "WENTYLE" "" nazwa1  "_s" styl_wentyle#w
                            "_j" "_bl" (list 0 0) wtext#w "0")
        (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_atrybut#w)(assoc 8 pr) pr))(entmod pr)
                                                              (ssadd (entlast) wskazB)  
         (command "_-STYLE" styld "" "" "" "" "" "" "")
         (command "_UCS" "_p")(command "_UCS" "_p")

(command "_UCS" "_w")(command "_UCS" "_o" pX)
;POINTY - wzgldem pX

(command "_POINT" (list 0 0) )(ssadd (entlast) wskazB)
(command "_POINT" (list (- (* 0.55 dd)) 0) )(ssadd (entlast) wskazB)

(command "_UCS" "_p")(command "_UCS" "_p")
(command "_LAYER" "_s" layer "") 

));progn/if not samepunkty#w


pX
);defun 




