;----------------------------------------------------
;procedura gwna obliczajca spadki cinie elementu
(defun obliczPa#w ( sciezkaPlik#w plik#w jm#w jm_wsp#w wszystkieKierPa#w listaDoPa#w / 
                    obi#w rozmiar#w kierunki#w kiery#w i#w j#w zwrot#w zwrotObi#w
                    figura#w akcesoria#w
		    dane#w ) 

;jm#w       "_cm#w"
;jm_wsp#w   "0.1"
;zmienna przenoszca razem wykryte kierunki we wszystkich obiektach tego typu
;  wszystkieKierPa#w np.(("P1>P3" "P1>P2")("P1>P2" "P1>P3"))
;po rozpakowaniu listy listaDoPa#w tworzy z jej rekordu:
;  obi#w
;  rozmiar#w  (("d1mm" "100") ("obw.m" "0.314") ("pole.m2" "0.008"))
;  kierunki#w (("P1" "d1mm" "100.00" (34.8437 30.4185 0.0) 
;               "P2" "d1mm" "100.00" (47.1028 30.4185 0.0)) 
;  kiery#w    ("P1>P2")
;  dalsze nie w kadym elemencie potrzebne:
;  figura#w   "12"
;  akcesoria#w (("" "")) lub (("WentyleSpiroRGS_akcesoria" "2")("WentyleSpiroRGS_lamelki" "1")
;                             ("WentyleSpiroRGS_przepustnica" "0"))  


;zaadowanie danych z pliku
(if (not dane#w)
    (progn (load (strcat sciezkaPlik#w plik#w "_PaData.lsp"))
           (setq dane#w (obliczPa1#w)) ))


;obliczenie spadku cinienia na elemencie
(setq zwrot#w '())
 
(foreach i#w listaDoPa#w
(progn  (setq obi#w (handent (car i#w))
	      rozmiar#w  (cadr i#w) 
              kiery#w    (caddr i#w)
              kierunki#w (cadddr i#w) )
	(setq p#w '())
	(while kiery#w (setq p#w     (append p#w (list (list (car kiery#w))))
			     kiery#w (cdr kiery#w)))
	(setq kiery#w p#w)


	(setq zwrotObi#w '())
	(foreach j#w kiery#w
	(progn

	(setq  zwrotObi#w (append zwrotObi#w (list (append (list j#w)
		          (liczyPa#w jm_wsp#w j#w rozmiar#w kierunki#w dane#w) ))))

	));progn/foreach j#w
        (if zwrotObi#w (setq zwrotObi#w (append (list obi#w) zwrotObi#w)))

(if zwrotObi#w (setq zwrot#w (append zwrot#w (list zwrotObi#w))))
));progn/foreach i#w

;zwrot#w ((<Entity name: 2792a90> (("P1>P2") "35" "0;Przekroczony zasig danych o spadkach!") 
;         (<Entity name: 2792cc8> (("P2>P1") "35" "0;Przekroczony zasig danych o spadkach!"))
zwrot#w
);defun











;podprocedura porednia obliczeniowa spadkw cinie
(defun liczyPa#w ( jm_wsp#w i#w rozmiar#w kierunki#w dane#w / listaZeStr>#w dmz#w a#w b#w a1#w b1#w d1#w l-2e#w kat#w
                   p#w pp#w p1#w p2#w error#w text#w f1dof2#w rozmrozm#w c#w c1#w kat1#w
                   kolejnosc#w dzeta#w reszta#w f#w f1#w wyd#w v#w ro#w dPa#w
		   kierTu#w j#w zwrot#w)

;i#w ("P2>P1") lub ("P1>P2")
;rozmiar#w (("A mm" "400") ("B mm" "400") ("d1mm" "150") ("L mm" "600") ("E mm" "25")) 
;kierunki#w (("P1" "axbmm" "200" (271.027 227.321 0.0) "P2" "a1xb1mm" "200" (301.027 226.321 0.0)))
;dane#w (gdy zwiksza(list "1" "0.1" "0.65") gdy zmniejsza(list "10" "0.1" "1.5") ...)

(setq p#w (car i#w) p1#w (substr p#w 1 2) p2#w (substr p#w 4 2))
(foreach j#w kierunki#w
(if (and (= (nth 0 j#w) p1#w) (= (nth 4 j#w) p2#w))(setq kierTu#w j#w)))

	
	(setq d1#w (atof (cadr (nth 2 rozmiar#w))))

	(cond
	((member (car i#w) '("P1>P2"))
	     (progn
		(setq a#w  (atof (cadr (nth 0 rozmiar#w)))
		      b#w  (atof (cadr (nth 1 rozmiar#w)))
		      a1#w d1#w
		      b1#w d1#w
		      f#w (* a#w b#w)
		      f1#w (/ (* pi (* d1#w d1#w)) 4) )
	     ));progn+

	((member (car i#w) '("P2>P1"))
	     (progn
		(setq a#w  d1#w
		      b#w  d1#w
		      a1#w (atof (cadr (nth 0 rozmiar#w)))
		      b1#w (atof (cadr (nth 1 rozmiar#w)))
		      f#w  (/ (* pi (* d1#w d1#w)) 4) 
		      f1#w (* a1#w b1#w))
	     ));progn+
	);cond

	;tu kt inaczej liczony ni w symetrycznej
	(setq l-2e#w (- (atof (cadr (nth 3 rozmiar#w))) (* 2 (atof (cadr (nth 4 rozmiar#w))))))
        (if (/= l-2e#w 0)(progn
	   (setq    kat#w (* (/ (atan (/ (abs (- a1#w a#w)) l-2e#w)) pi) 180) )

	;podmiana jeli kat w przekroju b wikszy ni w przekroju a
	    (setq kat1#w (* 2 (* (/ (atan (/ (/ (abs (- b1#w b#w)) 2) l-2e#w)) pi) 180)) )
	    (if (> kat1#w kat#w)(setq kat#w kat1#w))
	   );;;;progn
	  (progn
	    (setq kat#w 1)
	  )
	  )

	

	;zabezpieczenie zgodnoci kierunku rozwarcia i wartoci kta rozwarcia
	(cond
	;;;;;;;;;;;;;;;;((and (> (- a#w a1#w) 0) (< (- b#w b1#w) 0))(setq error#w "0;Przeciwne kty rozwarcia!"))
	;;;;;;;;;;;;;;;;((and (< (- a#w a1#w) 0) (> (- b#w b1#w) 0))(setq error#w "0;Przeciwne kty rozwarcia!"))

	((< kat#w 10.0) (setq error#w "0;Kt nie osiaga 10stopni!"))
	);cond


(if error#w (setq zwrot#w (list "" error#w))

;else - obliczenia
(progn

(cond

;Zmniejsza
;(stosunekF1/F2, Kt [stopnie], Dzeta)
((>= a#w a1#w)
     (progn     (setq f1dof2#w  (rtos (/ f#w f1#w) 2 3)
                      rozmrozm#w (rtos kat#w 2 2)
		      text#w "0;RedukcjaZmniej.")
     ));progn+

;Zwieksza
;(stosunekF1/F2, Kt [stopnie], Dzeta)
((< a#w a1#w)
     (progn     (setq f1dof2#w  (rtos (/ f#w f1#w) 2 3)
                      rozmrozm#w (rtos kat#w 2 2)
		      text#w "0;RedukcjaZwieksz.")
     ));progn+

);cond

(setq zwrot#w (LiczyPa_odczytDPa#w f1dof2#w rozmrozm#w dane#w))

	(setq dzeta#w   (car zwrot#w)
	      reszta#w (cadr zwrot#w))
				 ;pole na wlocie do redukcji
	(if (/= dzeta#w "")(setq f#w   (/ f#w 1000000)           	 ;[m2] 
				 wyd#w (/ (atof (nth 2 kierTu#w)) 3600)  ;[m3/s]
				 v#w   (/ wyd#w f#w)                     ;[m/s]
				 ro#w  1.2 ;[kg/m3] gsto powietrza
				dPa#w  (* (atof dzeta#w) (/ (* ro#w (* v#w v#w)) 2)) ;[Pa]
				zwrot#w (list  (rtos dPa#w 2 2) reszta#w)
			   ));setq/if

));progn else/if error#w


(if (and text#w (= (cadr zwrot#w) "")) (setq zwrot#w (list (car zwrot#w) text#w)))

zwrot#w   ;'("35" "Trjn.przelot") lub np. '("" "0;Przekroczony zakres na wykresie spadkw ci.") 
);defun 
