;----------------------------------------------------
;procedura gwna obliczajca spadki cinie elementu
(defun obliczPa#w ( sciezkaPlik#w plik#w jm#w jm_wsp#w wszystkieKierPa#w listaDoPa#w / 
                    obi#w rozmiar#w kierunki#w kiery#w i#w j#w zwrot#w zwrotObi#w
                    figura#w akcesoria#w
		    dane#w ) 

;jm#w       "_cm#w"
;jm_wsp#w   "0.1"
;zmienna przenoszca razem wykryte kierunki we wszystkich obiektach tego typu
;  wszystkieKierPa#w np.(("P1>P3" "P1>P2")("P1>P2" "P1>P3"))
;po rozpakowaniu listy listaDoPa#w tworzy z jej rekordu:
;  obi#w
;  rozmiar#w  (("d1mm" "100") ("obw.m" "0.314") ("pole.m2" "0.008"))
;  kierunki#w (("P1" "d1mm" "100.00" (34.8437 30.4185 0.0) 
;               "P2" "d1mm" "100.00" (47.1028 30.4185 0.0)) 
;  kiery#w    ("P1>P2")
;  dalsze nie w kadym elemencie potrzebne:
;  figura#w   "12"
;  akcesoria#w (("" "")) lub (("WentyleSpiroRGS_akcesoria" "2")("WentyleSpiroRGS_lamelki" "1")
;                             ("WentyleSpiroRGS_przepustnica" "0"))  




;zaadowanie danych z pliku
;Bl90
(if (not dane#w)
    (progn (load (strcat sciezkaPlik#w plik#w "_PaData.lsp"))
           (setq dane#w (obliczPa1#w)) ))


;obliczenie spadku cinienia na elemencie
(setq zwrot#w '())
 
(foreach i#w listaDoPa#w
(progn  (setq obi#w (handent (car i#w))
	      rozmiar#w  (cadr i#w) 
              kiery#w    (caddr i#w)
              kierunki#w (cadddr i#w) 
	      akcesoria#w (cadr (cddddr i#w)) )

	(setq p#w '())
	(while kiery#w (setq p#w     (append p#w (list (list (car kiery#w))))
			     kiery#w (cdr kiery#w)))
	(setq kiery#w p#w)


	(setq zwrotObi#w '())
	(foreach j#w kiery#w
	(progn

	;Bl90
	(setq  zwrotObi#w (append zwrotObi#w (list (append (list j#w)
		          (liczyPa#w jm_wsp#w j#w rozmiar#w kierunki#w akcesoria#w dane#w) ))))

	));progn/foreach j#w
        (if zwrotObi#w (setq zwrotObi#w (append (list obi#w) zwrotObi#w)))

(if zwrotObi#w (setq zwrot#w (append zwrot#w (list zwrotObi#w))))
));progn/foreach i#w

;zwrot#w ((<Entity name: 2792a90> (("P1>P2") "35" "0;Przekroczony zasig danych o spadkach!") 
;         (<Entity name: 2792cc8> (("P2>P1") "35" "0;Przekroczony zasig danych o spadkach!"))
zwrot#w
);defun











;podprocedura porednia obliczeniowa spadkw cinie
(defun liczyPa#w ( jm_wsp#w i#w rozmiar#w kierunki#w akcesoria#w dane#w / listaZeStr>#w dmz#w c#w b#w h#w
                   p#w pp#w p1#w p2#w error#w text#w
                   kolejnosc#w d#w dl#w wyd#w
		   kierTu#w j#w zwrot#w)

;  i#w ("P1>P2")
;  rozmiar#w  (("d1mm" "100") ("obw.m" "0.314") ("pole.m2" "0.008"))
;  kierunki#w (("P1" "d1mm" "100.00" (34.8437 30.4185 0.0) 
;               "P2" "d1mm" "100.00" (47.1028 30.4185 0.0)) 
;  dane#w (("80" "2.2" "1.1") ("80" "2.3" "1.2")...)

		;lokalna zwraca list z lancucha "aaaaa>bbb"
                (defun listaZeStr>#w ( x#w / p#w i#w t#w liczba#w wynik#w )
		      (setq p#w x#w   i#w 1  liczba#w ""  wynik#w '()) 
		      (while (/= (substr x#w i#w 1) ">") (setq i#w (+ i#w 1)))
		      (setq wynik (list (substr x#w 1 (- i#w 1))  (substr x#w  (+ i#w 1)) ))
		);defun lokalnej

(setq p#w (listaZeStr>#w (car i#w)) p1#w (car p#w) p2#w (cadr p#w))
(foreach j#w kierunki#w
(if (and (= (nth 0 j#w) p1#w) (= (nth 4 j#w) p2#w))(setq kierTu#w j#w)))


		(setq pp#w (cadr (assoc "WentyleSmFrapol_AL-JHZ-0_B" akcesoria#w)))
		(cond 
		      ((member pp#w '("0"))  (setq ppp#w "300"))
		      ((member pp#w '("1"))  (setq ppp#w "400"))
		      ((member pp#w '("2"))  (setq ppp#w "500"))
		      ((member pp#w '("3"))  (setq ppp#w "600"))
		      ((member pp#w '("4"))  (setq ppp#w "700"))
		      ((member pp#w '("5"))  (setq ppp#w "800"))
		      ((member pp#w '("6"))  (setq ppp#w "900"))
		      ((member pp#w '("7"))  (setq ppp#w "1000"))
		      ((member pp#w '("8"))  (setq ppp#w "1100"))
		      ((member pp#w '("9"))  (setq ppp#w "1200"))
		      ((member pp#w '("10"))  (setq ppp#w "1300"))
		      ((member pp#w '("11"))  (setq ppp#w "1400"))
		      ((member pp#w '("12"))  (setq ppp#w "1500"))
		      ((member pp#w '("13"))  (setq ppp#w "1600"))
		      ((member pp#w '("14"))  (setq ppp#w "1700"))
		      ((member pp#w '("15"))  (setq ppp#w "1800"))
		      ((member pp#w '("16"))  (setq ppp#w "1900"))
		      ((member pp#w '("17"))  (setq ppp#w "2000"))
		      ((member pp#w '("18"))  (setq ppp#w "2100"))
		      ((member pp#w '("19"))  (setq ppp#w "2200"))
		      ((member pp#w '("20"))  (setq ppp#w "2300"))
		      ((member pp#w '("21"))  (setq ppp#w "2400"))
		      ((member pp#w '("22"))  (setq ppp#w "2500"))
		);cond
		(setq b#w  (* 0.001 (atof ppp#w))) ;[m2]

		(setq pp#w (cadr (assoc "WentyleSmFrapol_AL-JHZ-0_H" akcesoria#w)))
		(cond 
		      ((member pp#w '("0"))  (setq ppp#w "205"))
		      ((member pp#w '("1"))  (setq ppp#w "305"))
		      ((member pp#w '("2"))  (setq ppp#w "405"))
		      ((member pp#w '("3"))  (setq ppp#w "505"))
		      ((member pp#w '("4"))  (setq ppp#w "605"))
		      ((member pp#w '("5"))  (setq ppp#w "705"))
		      ((member pp#w '("6"))  (setq ppp#w "805"))
		      ((member pp#w '("7"))  (setq ppp#w "905"))
		      ((member pp#w '("8"))  (setq ppp#w "1005"))
		      ((member pp#w '("9"))  (setq ppp#w "1105"))
		      ((member pp#w '("10"))  (setq ppp#w "1205"))
		      ((member pp#w '("11"))  (setq ppp#w "1305"))
		      ((member pp#w '("12"))  (setq ppp#w "1405"))
		      ((member pp#w '("13"))  (setq ppp#w "1505"))
		      ((member pp#w '("14"))  (setq ppp#w "1605"))
		      ((member pp#w '("15"))  (setq ppp#w "1705"))
		      ((member pp#w '("16"))  (setq ppp#w "1805"))
		      ((member pp#w '("17"))  (setq ppp#w "1905"))
		      ((member pp#w '("18"))  (setq ppp#w "2005"))
		);cond
		(setq h#w  (* 0.001 (atof ppp#w))) ;[m2]


		;wycignicie danych do bezporednich oblicze
		;;;(setq p#w   (nth 1 kierTu#w)
		(setq p#w   (* h#w b#w)				;[m2]
		      p#w   (* 0.85 p#w)			;[m2] powierzchnia efektywna, wspczynnik wyliczyem 
								;     prbkujc tabel rozmiarw
		      wyd#w (atof (nth 2 kierTu#w))		;[m3/h]
		      v#w   (/ (/ wyd#w p#w) 3600.0)  ;[m/s]
		      text#w "0;Przepustnica")

;(print p#w)
;(print v#w)


;wywoanie odczytu dPa z tablicy/wykresu
;(Przekrj ef., V[m/s], DPa[Pa])
(if (not error#w) 
(setq zwrot#w (LiczyPa_odczytDPa#w  (rtos p#w 2 12)
    		                    (rtos v#w 2 12)
			            dane#w) ));setq/if not error#w

(if (and text#w  (= (cadr zwrot#w) "")) (setq zwrot#w (list (car zwrot#w) text#w)))
(if (and error#w (= (cadr zwrot#w) "")) (setq zwrot#w (list (car zwrot#w) error#w)))

zwrot#w   ;'("35" "Trjn.przelot") 
	  ;lub np. '("" "0;Przekroczony zakres na wykresie spadkw ci.") 
);defun

