;----------------------------------------------------
;procedura gwna obliczajca spadki cinie elementu
(defun obliczPa#w ( sciezkaPlik#w plik#w jm#w jm_wsp#w wszystkieKierPa#w listaDoPa#w / 
                    obi#w rozmiar#w kierunki#w kiery#w i#w j#w zwrot#w zwrotObi#w
                    figura#w akcesoria#w
		    dane#w ) 

;jm#w       "_cm#w"
;jm_wsp#w   "0.1"
;zmienna przenoszca razem wykryte kierunki we wszystkich obiektach tego typu
;  wszystkieKierPa#w np.(("P1>P3" "P1>P2")("P1>P2" "P1>P3"))
;po rozpakowaniu listy listaDoPa#w tworzy z jej rekordu:
;  obi#w
;  rozmiar#w  (("d1mm" "100") ("obw.m" "0.314") ("pole.m2" "0.008"))
;  kierunki#w (("P1" "d1mm" "100.00" (34.8437 30.4185 0.0) 
;               "P2" "d1mm" "100.00" (47.1028 30.4185 0.0)) 
;  kiery#w    ("P1>P2")
;  dalsze nie w kadym elemencie potrzebne:
;  figura#w   "12"
;  akcesoria#w (("" "")) lub (("WentyleSpiroRGS_akcesoria" "2")("WentyleSpiroRGS_lamelki" "1")
;                             ("WentyleSpiroRGS_przepustnica" "0"))  


;zaadowanie danych z pliku
;Bl90
(if (not dane#w)
    (progn (load (strcat sciezkaPlik#w plik#w "_PaData.lsp"))
           (setq dane#w (obliczPa1#w)) ))


;obliczenie spadku cinienia na elemencie
(setq zwrot#w '())
 
(foreach i#w listaDoPa#w
(progn  (setq obi#w (handent (car i#w))
	      rozmiar#w  (cadr i#w) 
              kiery#w    (caddr i#w)
              kierunki#w (cadddr i#w)
	      akcesoria#w (cadr (cddddr i#w)) )
	(setq p#w '())
	(while kiery#w (setq p#w     (append p#w (list (list (car kiery#w))))
			     kiery#w (cdr kiery#w)))
	(setq kiery#w p#w)


	(setq zwrotObi#w '())
	(foreach j#w kiery#w
	(progn

	;Bl90
	(setq  zwrotObi#w (append zwrotObi#w (list (append (list j#w)
		          (liczyPa#w jm_wsp#w j#w rozmiar#w kierunki#w akcesoria#w dane#w) ))))

	));progn/foreach j#w
        (if zwrotObi#w (setq zwrotObi#w (append (list obi#w) zwrotObi#w)))

(if zwrotObi#w (setq zwrot#w (append zwrot#w (list zwrotObi#w))))
));progn/foreach i#w

;zwrot#w ((<Entity name: 2792a90> (("P1>P2") "35" "0;Przekroczony zasig danych o spadkach!") 
;         (<Entity name: 2792cc8> (("P2>P1") "35" "0;Przekroczony zasig danych o spadkach!"))
zwrot#w
);defun











;podprocedura porednia obliczeniowa spadkw cinie
(defun liczyPa#w ( jm_wsp#w i#w rozmiar#w kierunki#w akcesoria#w dane#w / listaZeStr>#w dmz#w c#w
                   p#w pp#w p1#w p2#w error#w text#w
                   kolejnosc#w d#w dl#w wyd#w pp#w ppp#w
		   kierTu#w j#w zwrot#w)

;  i#w ("P1>P2")
;  rozmiar#w  (("d1mm" "100") ("obw.m" "0.314") ("pole.m2" "0.008"))
;  kierunki#w (("P1" "d1mm" "100.00" (34.8437 30.4185 0.0) 
;               "P2" "d1mm" "100.00" (47.1028 30.4185 0.0)) 
;  dane#w (("80" "2.2" "1.1") ("80" "2.3" "1.2")...)

		;lokalna zwraca list z lancucha "aaaaa>bbb"
                (defun listaZeStr>#w ( x#w / p#w i#w t#w liczba#w wynik#w )
		      (setq p#w x#w   i#w 1  liczba#w ""  wynik#w '()) 
		      (while (/= (substr x#w i#w 1) ">") (setq i#w (+ i#w 1)))
		      (setq wynik (list (substr x#w 1 (- i#w 1))  (substr x#w  (+ i#w 1)) ))
		);defun lokalnej

(setq p#w (listaZeStr>#w (car i#w)) p1#w (car p#w) p2#w (cadr p#w))
(foreach j#w kierunki#w
(if (and (= (nth 0 j#w) p1#w) (= (nth 4 j#w) p2#w))(setq kierTu#w j#w)))


		(setq pp#w (cadr (assoc "WentyleSpiroFSBQ-IW_Klasa" akcesoria#w)))
			(cond ((member pp#w '("0"))  (setq ppp#w 200.0)) ;[Pa/m2]
		      	      ((member pp#w '("1"))  (setq ppp#w 450.0)) ;[Pa/m2]
		        );cond

		;wycignicie danych do bezporednich oblicze
		(setq p#w   (nth 1 kierTu#w)
                      d#w   p#w
		      d#w   (atof (cadr (assoc d#w rozmiar#w)))        ;[mm]
		      p#w   (/ (/ (* pi (* d#w d#w)) 4) 1000000.0)     ;[m2]

		      ;;wyd#w (atof (nth 2 kierTu#w))		;[m3/h]
		      text#w "0;Wkad filtra")

		(setq zwrot#w (list (rtos (* ppp#w p#w) 2 0) text#w))

zwrot#w   ;'("35" "Trjn.przelot") 
	  ;lub np. '("" "0;Przekroczony zakres na wykresie spadkw ci.") 
);defun

